/* grid.c generated by valac 0.56.17, the Vala compiler
 * generated from grid.vala, do not modify */

/*
   This file is part of GNOME 2048.

   Copyright (C) 2014-2015 Juan R. García Blanco <juanrgar@gmail.com>
   Copyright (C) 2016-2019 Arnaud Bonatti <arnaud.bonatti@gmail.com>

   GNOME 2048 is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME 2048 is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME 2048.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <math.h>
#include <float.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_GRID (grid_get_type ())
#define GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRID, Grid))
#define GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRID, GridClass))
#define IS_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRID))
#define IS_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRID))
#define GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRID, GridClass))

typedef struct _Grid Grid;
typedef struct _GridClass GridClass;
typedef struct _GridPrivate GridPrivate;
enum  {
	GRID_0_PROPERTY,
	GRID_ROWS_PROPERTY,
	GRID_COLS_PROPERTY,
	GRID_TARGET_VALUE_PROPERTY,
	GRID_TARGET_VALUE_SIMPLE_PROPERTY,
	GRID_TARGET_VALUE_REACHED_PROPERTY,
	GRID_NUM_PROPERTIES
};
static GParamSpec* grid_properties[GRID_NUM_PROPERTIES];

#define TYPE_TILE (tile_get_type ())
typedef struct _Tile Tile;

#define TYPE_GRID_POSITION (grid_position_get_type ())
typedef struct _GridPosition GridPosition;
typedef enum  {
	MOVE_REQUEST_UP,
	MOVE_REQUEST_RIGHT,
	MOVE_REQUEST_DOWN,
	MOVE_REQUEST_LEFT
} MoveRequest;

#define TYPE_MOVE_REQUEST (move_request_get_type ())

#define TYPE_TILE_MOVEMENT (tile_movement_get_type ())
typedef struct _TileMovement TileMovement;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Grid {
	GObject parent_instance;
	GridPrivate * priv;
	guint8* _grid;
	gint _grid_length1;
	gint _grid_length2;
};

struct _GridClass {
	GObjectClass parent_class;
};

struct _GridPrivate {
	guint8 _rows;
	guint8 _cols;
	guint _target_value;
	guint _target_value_simple;
	gboolean _target_value_reached;
};

struct _GridPosition {
	gint8 row;
	gint8 col;
};

struct _Tile {
	GridPosition pos;
	guint8 val;
};

struct _TileMovement {
	GridPosition from;
	GridPosition to;
};

static gint Grid_private_offset;
static gpointer grid_parent_class = NULL;

VALA_EXTERN GType grid_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Grid, g_object_unref)
VALA_EXTERN Grid* grid_new (guint8 rows,
                guint8 cols);
VALA_EXTERN Grid* grid_construct (GType object_type,
                      guint8 rows,
                      guint8 cols);
VALA_EXTERN GType tile_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType grid_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GridPosition* grid_position_dup (const GridPosition* self);
VALA_EXTERN void grid_position_free (GridPosition* self);
VALA_EXTERN Tile* tile_dup (const Tile* self);
VALA_EXTERN void tile_free (Tile* self);
VALA_EXTERN void grid_new_tile (Grid* self,
                    Tile* tile);
VALA_EXTERN gboolean _grid_grid_is_full (guint8** grid,
                             gint* grid_length1,
                             gint* grid_length2);
static inline void _grid_generate_random_position (guint8 rows,
                                     guint8 cols,
                                     GridPosition* pos);
VALA_EXTERN guint8 grid_get_rows (Grid* self);
VALA_EXTERN guint8 grid_get_cols (Grid* self);
VALA_EXTERN GType move_request_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tile_movement_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TileMovement* tile_movement_dup (const TileMovement* self);
VALA_EXTERN void tile_movement_free (TileMovement* self);
VALA_EXTERN void grid_move (Grid* self,
                MoveRequest request,
                GeeLinkedList** to_move,
                GeeLinkedList** to_hide,
                GeeLinkedList** to_show);
static void _grid_move_down (gint8 cols,
                      gint8 rows,
                      guint8* max_changed,
                      guint8** grid,
                      gint* grid_length1,
                      gint* grid_length2,
                      GeeLinkedList** to_move,
                      GeeLinkedList** to_hide,
                      GeeLinkedList** to_show);
static void _grid_move_up (gint8 cols,
                    gint8 rows,
                    guint8* max_changed,
                    guint8** grid,
                    gint* grid_length1,
                    gint* grid_length2,
                    GeeLinkedList** to_move,
                    GeeLinkedList** to_hide,
                    GeeLinkedList** to_show);
static void _grid_move_left (gint8 cols,
                      gint8 rows,
                      guint8* max_changed,
                      guint8** grid,
                      gint* grid_length1,
                      gint* grid_length2,
                      GeeLinkedList** to_move,
                      GeeLinkedList** to_hide,
                      GeeLinkedList** to_show);
static void _grid_move_right (gint8 cols,
                       gint8 rows,
                       guint8* max_changed,
                       guint8** grid,
                       gint* grid_length1,
                       gint* grid_length2,
                       GeeLinkedList** to_move,
                       GeeLinkedList** to_hide,
                       GeeLinkedList** to_show);
VALA_EXTERN guint grid_get_target_value (Grid* self);
static void grid_set_target_value_simple (Grid* self,
                                   guint value);
VALA_EXTERN void grid_set_target_value_reached (Grid* self,
                                    gboolean value);
static void _grid_move_to_match (GeeLinkedList** to_hide,
                          GeeLinkedList** to_show,
                          GridPosition* cur,
                          GridPosition* free,
                          GridPosition* match,
                          guint8** grid,
                          gint* grid_length1,
                          gint* grid_length2,
                          guint8* val,
                          guint8* max_changed);
static void _grid_move_to_end (GeeLinkedList** to_move,
                        GridPosition* cur,
                        GridPosition* free,
                        guint8** grid,
                        gint* grid_length1,
                        gint* grid_length2,
                        guint8* val);
VALA_EXTERN gchar* grid_position_to_string (GridPosition *self);
VALA_EXTERN gboolean grid_is_finished (Grid* self);
VALA_EXTERN void grid_clear (Grid* self);
static void _grid_clear (guint8** grid,
                  gint* grid_length1,
                  gint* grid_length2);
VALA_EXTERN glong grid_get_score (Grid* self);
static glong _grid_get_score (guint8** grid,
                       gint* grid_length1,
                       gint* grid_length2);
static inline glong _grid_calculate_score_value (guint8 tile_value);
VALA_EXTERN Grid* grid_clone (Grid* self);
static guint8* _vala_array_dup1 (guint8* self,
                          gssize length);
VALA_EXTERN guint8 grid_get (Grid* self,
                 guint8 row,
                 guint8 col);
VALA_EXTERN gboolean grid_is_disallowed_grid_size (guint8* rows,
                                       guint8* cols);
VALA_EXTERN gchar* grid_save (Grid* self);
static void _grid_convert_to_string (guint8** grid,
                              gint* grid_length1,
                              gint* grid_length2,
                              gchar** ret_string);
VALA_EXTERN gchar* grid_to_string (Grid* self);
VALA_EXTERN gboolean grid_load (Grid* self,
                    gchar** content);
static gboolean _grid_load_from_string (gchar** content,
                                 guint8** grid,
                                 gint* grid_length1,
                                 gint* grid_length2);
static guint8* _vala_array_dup2 (guint8* self,
                          gssize length);
static inline void _grid_parse_line (const gchar* line,
                       gchar*** tokens,
                       gint* tokens_length1);
static inline gboolean _grid_convert_tile_number (guint64* number_64,
                                    guint8* number);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
VALA_EXTERN void grid_save_game (Grid* self,
                     const gchar* path);
VALA_EXTERN gboolean grid_restore_game (Grid* self,
                            const gchar* path);
static void grid_set_rows (Grid* self,
                    guint8 value);
static void grid_set_cols (Grid* self,
                    guint8 value);
VALA_EXTERN void grid_set_target_value (Grid* self,
                            guint value);
VALA_EXTERN guint grid_get_target_value_simple (Grid* self);
VALA_EXTERN gboolean grid_get_target_value_reached (Grid* self);
static GObject * grid_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void grid_finalize (GObject * obj);
static GType grid_get_type_once (void);
static void _vala_grid_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_grid_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
VALA_EXTERN gchar* move_request_debug_string (MoveRequest request);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
grid_get_instance_private (Grid* self)
{
	return G_STRUCT_MEMBER_P (self, Grid_private_offset);
}

Grid*
grid_construct (GType object_type,
                guint8 rows,
                guint8 cols)
{
	Grid * self = NULL;
#line 43 "../src/grid.vala"
	self = (Grid*) g_object_new (object_type, "rows", rows, "cols", cols, NULL);
#line 41 "../src/grid.vala"
	return self;
#line 321 "grid.c"
}

Grid*
grid_new (guint8 rows,
          guint8 cols)
{
#line 41 "../src/grid.vala"
	return grid_construct (TYPE_GRID, rows, cols);
#line 330 "grid.c"
}

void
grid_new_tile (Grid* self,
               Tile* tile)
{
	Tile _vala_tile = {0};
	gboolean _tmp0_;
	GridPosition pos = {0};
	GridPosition _tmp1_ = {0};
	guint8* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	GridPosition _tmp11_;
	GridPosition _tmp12_;
	GridPosition _tmp13_;
	Tile _tmp14_ = {0};
#line 50 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/grid.vala"
	_tmp0_ = _grid_grid_is_full (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 52 "../src/grid.vala"
	if (_tmp0_) {
#line 53 "../src/grid.vala"
		g_assert_not_reached ();
#line 356 "grid.c"
	}
#line 55 "../src/grid.vala"
	_tmp1_.row = (gint8) 0;
#line 55 "../src/grid.vala"
	_tmp1_.col = (gint8) 0;
#line 55 "../src/grid.vala"
	pos = _tmp1_;
#line 364 "grid.c"
	{
		gboolean _tmp2_ = FALSE;
#line 56 "../src/grid.vala"
		_tmp2_ = TRUE;
#line 56 "../src/grid.vala"
		while (TRUE) {
#line 371 "grid.c"
			guint8 _tmp7_;
			guint8 _tmp8_;
			GridPosition _tmp9_ = {0};
#line 56 "../src/grid.vala"
			if (!_tmp2_) {
#line 377 "grid.c"
				guint8* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				GridPosition _tmp4_;
				GridPosition _tmp5_;
				guint8 _tmp6_;
#line 57 "../src/grid.vala"
				_tmp3_ = self->_grid;
#line 57 "../src/grid.vala"
				_tmp3__length1 = self->_grid_length1;
#line 57 "../src/grid.vala"
				_tmp3__length2 = self->_grid_length2;
#line 57 "../src/grid.vala"
				_tmp4_ = pos;
#line 57 "../src/grid.vala"
				_tmp5_ = pos;
#line 57 "../src/grid.vala"
				_tmp6_ = _tmp3_[(_tmp4_.row * _tmp3__length2) + _tmp5_.col];
#line 57 "../src/grid.vala"
				if (!(((gint) _tmp6_) != 0)) {
#line 57 "../src/grid.vala"
					break;
#line 400 "grid.c"
				}
			}
#line 56 "../src/grid.vala"
			_tmp2_ = FALSE;
#line 56 "../src/grid.vala"
			_tmp7_ = self->priv->_rows;
#line 56 "../src/grid.vala"
			_tmp8_ = self->priv->_cols;
#line 56 "../src/grid.vala"
			_grid_generate_random_position (_tmp7_, _tmp8_, &_tmp9_);
#line 56 "../src/grid.vala"
			pos = _tmp9_;
#line 413 "grid.c"
		}
	}
#line 59 "../src/grid.vala"
	_tmp10_ = self->_grid;
#line 59 "../src/grid.vala"
	_tmp10__length1 = self->_grid_length1;
#line 59 "../src/grid.vala"
	_tmp10__length2 = self->_grid_length2;
#line 59 "../src/grid.vala"
	_tmp11_ = pos;
#line 59 "../src/grid.vala"
	_tmp12_ = pos;
#line 59 "../src/grid.vala"
	_tmp10_[(_tmp11_.row * _tmp10__length2) + _tmp12_.col] = (guint8) 1;
#line 60 "../src/grid.vala"
	_tmp13_ = pos;
#line 60 "../src/grid.vala"
	_tmp14_.pos = _tmp13_;
#line 60 "../src/grid.vala"
	_tmp14_.val = (guint8) 1;
#line 60 "../src/grid.vala"
	_vala_tile = _tmp14_;
#line 50 "../src/grid.vala"
	if (tile) {
#line 50 "../src/grid.vala"
		*tile = _vala_tile;
#line 440 "grid.c"
	}
}

static inline void
_grid_generate_random_position (guint8 rows,
                                guint8 cols,
                                GridPosition* pos)
{
	GridPosition _vala_pos = {0};
	GridPosition _tmp0_ = {0};
#line 65 "../src/grid.vala"
	_tmp0_.row = (gint8) g_random_int_range ((gint32) 0, (gint32) rows);
#line 65 "../src/grid.vala"
	_tmp0_.col = (gint8) g_random_int_range ((gint32) 0, (gint32) cols);
#line 65 "../src/grid.vala"
	_vala_pos = _tmp0_;
#line 63 "../src/grid.vala"
	if (pos) {
#line 63 "../src/grid.vala"
		*pos = _vala_pos;
#line 461 "grid.c"
	}
}

inline void
grid_move (Grid* self,
           MoveRequest request,
           GeeLinkedList** to_move,
           GeeLinkedList** to_hide,
           GeeLinkedList** to_show)
{
	guint8 max_changed = 0U;
	guint _tmp0_;
#line 73 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 73 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 73 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 78 "../src/grid.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) (*to_move));
#line 79 "../src/grid.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) (*to_hide));
#line 80 "../src/grid.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) (*to_show));
#line 82 "../src/grid.vala"
	max_changed = (guint8) 0;
#line 83 "../src/grid.vala"
	switch (request) {
#line 83 "../src/grid.vala"
		case MOVE_REQUEST_DOWN:
#line 494 "grid.c"
		{
#line 86 "../src/grid.vala"
			_grid_move_down ((gint8) self->priv->_cols, (gint8) self->priv->_rows, &max_changed, &self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), to_move, to_hide, to_show);
#line 86 "../src/grid.vala"
			break;
#line 500 "grid.c"
		}
#line 83 "../src/grid.vala"
		case MOVE_REQUEST_UP:
#line 504 "grid.c"
		{
#line 88 "../src/grid.vala"
			_grid_move_up ((gint8) self->priv->_cols, (gint8) self->priv->_rows, &max_changed, &self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), to_move, to_hide, to_show);
#line 88 "../src/grid.vala"
			break;
#line 510 "grid.c"
		}
#line 83 "../src/grid.vala"
		case MOVE_REQUEST_LEFT:
#line 514 "grid.c"
		{
#line 90 "../src/grid.vala"
			_grid_move_left ((gint8) self->priv->_cols, (gint8) self->priv->_rows, &max_changed, &self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), to_move, to_hide, to_show);
#line 90 "../src/grid.vala"
			break;
#line 520 "grid.c"
		}
#line 83 "../src/grid.vala"
		case MOVE_REQUEST_RIGHT:
#line 524 "grid.c"
		{
#line 92 "../src/grid.vala"
			_grid_move_right ((gint8) self->priv->_cols, (gint8) self->priv->_rows, &max_changed, &self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), to_move, to_hide, to_show);
#line 92 "../src/grid.vala"
			break;
#line 530 "grid.c"
		}
		default:
#line 83 "../src/grid.vala"
		break;
#line 535 "grid.c"
	}
#line 94 "../src/grid.vala"
	_tmp0_ = self->priv->_target_value;
#line 94 "../src/grid.vala"
	if (pow ((gdouble) 2, (gdouble) max_changed) >= ((gdouble) _tmp0_)) {
#line 96 "../src/grid.vala"
		grid_set_target_value_simple (self, (guint) max_changed);
#line 97 "../src/grid.vala"
		grid_set_target_value_reached (self, TRUE);
#line 545 "grid.c"
	}
}

static void
_grid_move_down (gint8 cols,
                 gint8 rows,
                 guint8* max_changed,
                 guint8** grid,
                 gint* grid_length1,
                 gint* grid_length2,
                 GeeLinkedList** to_move,
                 GeeLinkedList** to_hide,
                 GeeLinkedList** to_show)
{
#line 101 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 101 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 101 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 566 "grid.c"
	{
		gint8 i = 0;
#line 109 "../src/grid.vala"
		i = (gint8) 0;
#line 571 "grid.c"
		{
			gboolean _tmp0_ = FALSE;
#line 109 "../src/grid.vala"
			_tmp0_ = TRUE;
#line 109 "../src/grid.vala"
			while (TRUE) {
#line 578 "grid.c"
				GridPosition free = {0};
				GridPosition _tmp2_ = {0};
#line 109 "../src/grid.vala"
				if (!_tmp0_) {
#line 583 "grid.c"
					gint8 _tmp1_;
#line 109 "../src/grid.vala"
					_tmp1_ = i;
#line 109 "../src/grid.vala"
					i = _tmp1_ + 1;
#line 589 "grid.c"
				}
#line 109 "../src/grid.vala"
				_tmp0_ = FALSE;
#line 109 "../src/grid.vala"
				if (!(i < cols)) {
#line 109 "../src/grid.vala"
					break;
#line 597 "grid.c"
				}
#line 111 "../src/grid.vala"
				_tmp2_.row = rows;
#line 111 "../src/grid.vala"
				_tmp2_.col = i;
#line 111 "../src/grid.vala"
				free = _tmp2_;
#line 605 "grid.c"
				{
					gint8 j = 0;
#line 113 "../src/grid.vala"
					j = (gint8) 0;
#line 610 "grid.c"
					{
						gboolean _tmp3_ = FALSE;
#line 113 "../src/grid.vala"
						_tmp3_ = TRUE;
#line 113 "../src/grid.vala"
						while (TRUE) {
#line 617 "grid.c"
							gint8 row = 0;
							GridPosition cur = {0};
							GridPosition _tmp5_ = {0};
							guint8 val = 0U;
							GridPosition _tmp6_;
							GridPosition _tmp7_;
							guint8 _tmp8_;
							GridPosition match = {0};
							GridPosition _tmp10_ = {0};
							gboolean has_match = FALSE;
#line 113 "../src/grid.vala"
							if (!_tmp3_) {
#line 630 "grid.c"
								gint8 _tmp4_;
#line 113 "../src/grid.vala"
								_tmp4_ = j;
#line 113 "../src/grid.vala"
								j = _tmp4_ + 1;
#line 636 "grid.c"
							}
#line 113 "../src/grid.vala"
							_tmp3_ = FALSE;
#line 113 "../src/grid.vala"
							if (!(j < rows)) {
#line 113 "../src/grid.vala"
								break;
#line 644 "grid.c"
							}
#line 115 "../src/grid.vala"
							row = (gint8) ((rows - j) - 1);
#line 116 "../src/grid.vala"
							_tmp5_.row = row;
#line 116 "../src/grid.vala"
							_tmp5_.col = i;
#line 116 "../src/grid.vala"
							cur = _tmp5_;
#line 117 "../src/grid.vala"
							_tmp6_ = cur;
#line 117 "../src/grid.vala"
							_tmp7_ = cur;
#line 117 "../src/grid.vala"
							_tmp8_ = (*grid)[(_tmp6_.row * (*grid_length2)) + _tmp7_.col];
#line 117 "../src/grid.vala"
							val = _tmp8_;
#line 119 "../src/grid.vala"
							if (((gint) val) == 0) {
#line 664 "grid.c"
								GridPosition _tmp9_;
#line 121 "../src/grid.vala"
								_tmp9_ = free;
#line 121 "../src/grid.vala"
								if (_tmp9_.row == rows) {
#line 122 "../src/grid.vala"
									free.row = row;
#line 672 "grid.c"
								}
#line 123 "../src/grid.vala"
								continue;
#line 676 "grid.c"
							}
#line 127 "../src/grid.vala"
							_tmp10_.row = (gint8) 0;
#line 127 "../src/grid.vala"
							_tmp10_.col = (gint8) 0;
#line 127 "../src/grid.vala"
							match = _tmp10_;
#line 128 "../src/grid.vala"
							has_match = FALSE;
#line 686 "grid.c"
							{
								gint8 k = 0;
#line 129 "../src/grid.vala"
								k = (gint8) (row - 1);
#line 691 "grid.c"
								{
									gboolean _tmp11_ = FALSE;
#line 129 "../src/grid.vala"
									_tmp11_ = TRUE;
#line 129 "../src/grid.vala"
									while (TRUE) {
#line 698 "grid.c"
										guint8 k_val = 0U;
										GridPosition _tmp13_;
										guint8 _tmp14_;
#line 129 "../src/grid.vala"
										if (!_tmp11_) {
#line 704 "grid.c"
											gint8 _tmp12_;
#line 129 "../src/grid.vala"
											_tmp12_ = k;
#line 129 "../src/grid.vala"
											k = _tmp12_ - 1;
#line 710 "grid.c"
										}
#line 129 "../src/grid.vala"
										_tmp11_ = FALSE;
#line 129 "../src/grid.vala"
										if (!(((gint) k) >= 0)) {
#line 129 "../src/grid.vala"
											break;
#line 718 "grid.c"
										}
#line 131 "../src/grid.vala"
										_tmp13_ = cur;
#line 131 "../src/grid.vala"
										_tmp14_ = (*grid)[(k * (*grid_length2)) + _tmp13_.col];
#line 131 "../src/grid.vala"
										k_val = _tmp14_;
#line 133 "../src/grid.vala"
										if (((gint) k_val) != 0) {
#line 135 "../src/grid.vala"
											if (k_val == val) {
#line 730 "grid.c"
												GridPosition _tmp15_;
												GridPosition _tmp16_ = {0};
#line 137 "../src/grid.vala"
												has_match = TRUE;
#line 138 "../src/grid.vala"
												_tmp15_ = cur;
#line 138 "../src/grid.vala"
												_tmp16_.row = k;
#line 138 "../src/grid.vala"
												_tmp16_.col = _tmp15_.col;
#line 138 "../src/grid.vala"
												match = _tmp16_;
#line 743 "grid.c"
											}
#line 140 "../src/grid.vala"
											break;
#line 747 "grid.c"
										}
									}
								}
							}
#line 144 "../src/grid.vala"
							if (has_match) {
#line 754 "grid.c"
								GridPosition _tmp17_;
								gint8 _tmp18_;
#line 146 "../src/grid.vala"
								_tmp17_ = free;
#line 146 "../src/grid.vala"
								if (_tmp17_.row == rows) {
#line 147 "../src/grid.vala"
									free.row = row;
#line 763 "grid.c"
								}
#line 149 "../src/grid.vala"
								_grid_move_to_match (to_hide, to_show, &cur, &free, &match, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val, max_changed);
#line 150 "../src/grid.vala"
								_tmp18_ = free.row;
#line 150 "../src/grid.vala"
								free.row = _tmp18_ - 1;
#line 771 "grid.c"
							} else {
								GridPosition _tmp19_;
#line 152 "../src/grid.vala"
								_tmp19_ = free;
#line 152 "../src/grid.vala"
								if (_tmp19_.row != rows) {
#line 778 "grid.c"
									gint8 _tmp20_;
#line 154 "../src/grid.vala"
									_grid_move_to_end (to_move, &cur, &free, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val);
#line 155 "../src/grid.vala"
									_tmp20_ = free.row;
#line 155 "../src/grid.vala"
									free.row = _tmp20_ - 1;
#line 786 "grid.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
_grid_move_up (gint8 cols,
               gint8 rows,
               guint8* max_changed,
               guint8** grid,
               gint* grid_length1,
               gint* grid_length2,
               GeeLinkedList** to_move,
               GeeLinkedList** to_hide,
               GeeLinkedList** to_show)
{
#line 161 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 161 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 161 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 814 "grid.c"
	{
		gint8 i = 0;
#line 169 "../src/grid.vala"
		i = (gint8) 0;
#line 819 "grid.c"
		{
			gboolean _tmp0_ = FALSE;
#line 169 "../src/grid.vala"
			_tmp0_ = TRUE;
#line 169 "../src/grid.vala"
			while (TRUE) {
#line 826 "grid.c"
				GridPosition free = {0};
				GridPosition _tmp2_ = {0};
#line 169 "../src/grid.vala"
				if (!_tmp0_) {
#line 831 "grid.c"
					gint8 _tmp1_;
#line 169 "../src/grid.vala"
					_tmp1_ = i;
#line 169 "../src/grid.vala"
					i = _tmp1_ + 1;
#line 837 "grid.c"
				}
#line 169 "../src/grid.vala"
				_tmp0_ = FALSE;
#line 169 "../src/grid.vala"
				if (!(i < cols)) {
#line 169 "../src/grid.vala"
					break;
#line 845 "grid.c"
				}
#line 171 "../src/grid.vala"
				_tmp2_.row = (gint8) -1;
#line 171 "../src/grid.vala"
				_tmp2_.col = i;
#line 171 "../src/grid.vala"
				free = _tmp2_;
#line 853 "grid.c"
				{
					gint8 j = 0;
#line 173 "../src/grid.vala"
					j = (gint8) 0;
#line 858 "grid.c"
					{
						gboolean _tmp3_ = FALSE;
#line 173 "../src/grid.vala"
						_tmp3_ = TRUE;
#line 173 "../src/grid.vala"
						while (TRUE) {
#line 865 "grid.c"
							gint8 row = 0;
							GridPosition cur = {0};
							GridPosition _tmp5_ = {0};
							guint8 val = 0U;
							GridPosition _tmp6_;
							GridPosition _tmp7_;
							guint8 _tmp8_;
							GridPosition match = {0};
							GridPosition _tmp10_ = {0};
							gboolean has_match = FALSE;
#line 173 "../src/grid.vala"
							if (!_tmp3_) {
#line 878 "grid.c"
								gint8 _tmp4_;
#line 173 "../src/grid.vala"
								_tmp4_ = j;
#line 173 "../src/grid.vala"
								j = _tmp4_ + 1;
#line 884 "grid.c"
							}
#line 173 "../src/grid.vala"
							_tmp3_ = FALSE;
#line 173 "../src/grid.vala"
							if (!(j < rows)) {
#line 173 "../src/grid.vala"
								break;
#line 892 "grid.c"
							}
#line 175 "../src/grid.vala"
							row = j;
#line 176 "../src/grid.vala"
							_tmp5_.row = row;
#line 176 "../src/grid.vala"
							_tmp5_.col = i;
#line 176 "../src/grid.vala"
							cur = _tmp5_;
#line 177 "../src/grid.vala"
							_tmp6_ = cur;
#line 177 "../src/grid.vala"
							_tmp7_ = cur;
#line 177 "../src/grid.vala"
							_tmp8_ = (*grid)[(_tmp6_.row * (*grid_length2)) + _tmp7_.col];
#line 177 "../src/grid.vala"
							val = _tmp8_;
#line 179 "../src/grid.vala"
							if (((gint) val) == 0) {
#line 912 "grid.c"
								GridPosition _tmp9_;
#line 181 "../src/grid.vala"
								_tmp9_ = free;
#line 181 "../src/grid.vala"
								if (((gint) _tmp9_.row) == -1) {
#line 182 "../src/grid.vala"
									free.row = row;
#line 920 "grid.c"
								}
#line 183 "../src/grid.vala"
								continue;
#line 924 "grid.c"
							}
#line 187 "../src/grid.vala"
							_tmp10_.row = (gint8) 0;
#line 187 "../src/grid.vala"
							_tmp10_.col = (gint8) 0;
#line 187 "../src/grid.vala"
							match = _tmp10_;
#line 188 "../src/grid.vala"
							has_match = FALSE;
#line 934 "grid.c"
							{
								gint8 k = 0;
#line 189 "../src/grid.vala"
								k = (gint8) (row + 1);
#line 939 "grid.c"
								{
									gboolean _tmp11_ = FALSE;
#line 189 "../src/grid.vala"
									_tmp11_ = TRUE;
#line 189 "../src/grid.vala"
									while (TRUE) {
#line 946 "grid.c"
										guint8 k_val = 0U;
										GridPosition _tmp13_;
										guint8 _tmp14_;
#line 189 "../src/grid.vala"
										if (!_tmp11_) {
#line 952 "grid.c"
											gint8 _tmp12_;
#line 189 "../src/grid.vala"
											_tmp12_ = k;
#line 189 "../src/grid.vala"
											k = _tmp12_ + 1;
#line 958 "grid.c"
										}
#line 189 "../src/grid.vala"
										_tmp11_ = FALSE;
#line 189 "../src/grid.vala"
										if (!(k < rows)) {
#line 189 "../src/grid.vala"
											break;
#line 966 "grid.c"
										}
#line 191 "../src/grid.vala"
										_tmp13_ = cur;
#line 191 "../src/grid.vala"
										_tmp14_ = (*grid)[(k * (*grid_length2)) + _tmp13_.col];
#line 191 "../src/grid.vala"
										k_val = _tmp14_;
#line 193 "../src/grid.vala"
										if (((gint) k_val) != 0) {
#line 195 "../src/grid.vala"
											if (k_val == val) {
#line 978 "grid.c"
												GridPosition _tmp15_;
												GridPosition _tmp16_ = {0};
#line 197 "../src/grid.vala"
												has_match = TRUE;
#line 198 "../src/grid.vala"
												_tmp15_ = cur;
#line 198 "../src/grid.vala"
												_tmp16_.row = k;
#line 198 "../src/grid.vala"
												_tmp16_.col = _tmp15_.col;
#line 198 "../src/grid.vala"
												match = _tmp16_;
#line 991 "grid.c"
											}
#line 200 "../src/grid.vala"
											break;
#line 995 "grid.c"
										}
									}
								}
							}
#line 204 "../src/grid.vala"
							if (has_match) {
#line 1002 "grid.c"
								GridPosition _tmp17_;
								gint8 _tmp18_;
#line 206 "../src/grid.vala"
								_tmp17_ = free;
#line 206 "../src/grid.vala"
								if (((gint) _tmp17_.row) == -1) {
#line 207 "../src/grid.vala"
									free.row = row;
#line 1011 "grid.c"
								}
#line 209 "../src/grid.vala"
								_grid_move_to_match (to_hide, to_show, &cur, &free, &match, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val, max_changed);
#line 210 "../src/grid.vala"
								_tmp18_ = free.row;
#line 210 "../src/grid.vala"
								free.row = _tmp18_ + 1;
#line 1019 "grid.c"
							} else {
								GridPosition _tmp19_;
#line 212 "../src/grid.vala"
								_tmp19_ = free;
#line 212 "../src/grid.vala"
								if (((gint) _tmp19_.row) != -1) {
#line 1026 "grid.c"
									gint8 _tmp20_;
#line 214 "../src/grid.vala"
									_grid_move_to_end (to_move, &cur, &free, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val);
#line 215 "../src/grid.vala"
									_tmp20_ = free.row;
#line 215 "../src/grid.vala"
									free.row = _tmp20_ + 1;
#line 1034 "grid.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
_grid_move_left (gint8 cols,
                 gint8 rows,
                 guint8* max_changed,
                 guint8** grid,
                 gint* grid_length1,
                 gint* grid_length2,
                 GeeLinkedList** to_move,
                 GeeLinkedList** to_hide,
                 GeeLinkedList** to_show)
{
#line 221 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 221 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 221 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 1062 "grid.c"
	{
		gint8 i = 0;
#line 229 "../src/grid.vala"
		i = (gint8) 0;
#line 1067 "grid.c"
		{
			gboolean _tmp0_ = FALSE;
#line 229 "../src/grid.vala"
			_tmp0_ = TRUE;
#line 229 "../src/grid.vala"
			while (TRUE) {
#line 1074 "grid.c"
				GridPosition free = {0};
				GridPosition _tmp2_ = {0};
#line 229 "../src/grid.vala"
				if (!_tmp0_) {
#line 1079 "grid.c"
					gint8 _tmp1_;
#line 229 "../src/grid.vala"
					_tmp1_ = i;
#line 229 "../src/grid.vala"
					i = _tmp1_ + 1;
#line 1085 "grid.c"
				}
#line 229 "../src/grid.vala"
				_tmp0_ = FALSE;
#line 229 "../src/grid.vala"
				if (!(i < rows)) {
#line 229 "../src/grid.vala"
					break;
#line 1093 "grid.c"
				}
#line 231 "../src/grid.vala"
				_tmp2_.row = i;
#line 231 "../src/grid.vala"
				_tmp2_.col = (gint8) -1;
#line 231 "../src/grid.vala"
				free = _tmp2_;
#line 1101 "grid.c"
				{
					gint8 j = 0;
#line 233 "../src/grid.vala"
					j = (gint8) 0;
#line 1106 "grid.c"
					{
						gboolean _tmp3_ = FALSE;
#line 233 "../src/grid.vala"
						_tmp3_ = TRUE;
#line 233 "../src/grid.vala"
						while (TRUE) {
#line 1113 "grid.c"
							gint8 col = 0;
							GridPosition cur = {0};
							GridPosition _tmp5_ = {0};
							guint8 val = 0U;
							GridPosition _tmp6_;
							GridPosition _tmp7_;
							guint8 _tmp8_;
							GridPosition match = {0};
							GridPosition _tmp10_ = {0};
							gboolean has_match = FALSE;
#line 233 "../src/grid.vala"
							if (!_tmp3_) {
#line 1126 "grid.c"
								gint8 _tmp4_;
#line 233 "../src/grid.vala"
								_tmp4_ = j;
#line 233 "../src/grid.vala"
								j = _tmp4_ + 1;
#line 1132 "grid.c"
							}
#line 233 "../src/grid.vala"
							_tmp3_ = FALSE;
#line 233 "../src/grid.vala"
							if (!(j < cols)) {
#line 233 "../src/grid.vala"
								break;
#line 1140 "grid.c"
							}
#line 235 "../src/grid.vala"
							col = j;
#line 236 "../src/grid.vala"
							_tmp5_.row = i;
#line 236 "../src/grid.vala"
							_tmp5_.col = col;
#line 236 "../src/grid.vala"
							cur = _tmp5_;
#line 237 "../src/grid.vala"
							_tmp6_ = cur;
#line 237 "../src/grid.vala"
							_tmp7_ = cur;
#line 237 "../src/grid.vala"
							_tmp8_ = (*grid)[(_tmp6_.row * (*grid_length2)) + _tmp7_.col];
#line 237 "../src/grid.vala"
							val = _tmp8_;
#line 239 "../src/grid.vala"
							if (((gint) val) == 0) {
#line 1160 "grid.c"
								GridPosition _tmp9_;
#line 241 "../src/grid.vala"
								_tmp9_ = free;
#line 241 "../src/grid.vala"
								if (((gint) _tmp9_.col) == -1) {
#line 242 "../src/grid.vala"
									free.col = col;
#line 1168 "grid.c"
								}
#line 243 "../src/grid.vala"
								continue;
#line 1172 "grid.c"
							}
#line 247 "../src/grid.vala"
							_tmp10_.row = (gint8) 0;
#line 247 "../src/grid.vala"
							_tmp10_.col = (gint8) 0;
#line 247 "../src/grid.vala"
							match = _tmp10_;
#line 248 "../src/grid.vala"
							has_match = FALSE;
#line 1182 "grid.c"
							{
								gint8 k = 0;
#line 249 "../src/grid.vala"
								k = (gint8) (col + 1);
#line 1187 "grid.c"
								{
									gboolean _tmp11_ = FALSE;
#line 249 "../src/grid.vala"
									_tmp11_ = TRUE;
#line 249 "../src/grid.vala"
									while (TRUE) {
#line 1194 "grid.c"
										guint8 k_val = 0U;
										GridPosition _tmp13_;
										guint8 _tmp14_;
#line 249 "../src/grid.vala"
										if (!_tmp11_) {
#line 1200 "grid.c"
											gint8 _tmp12_;
#line 249 "../src/grid.vala"
											_tmp12_ = k;
#line 249 "../src/grid.vala"
											k = _tmp12_ + 1;
#line 1206 "grid.c"
										}
#line 249 "../src/grid.vala"
										_tmp11_ = FALSE;
#line 249 "../src/grid.vala"
										if (!(k < cols)) {
#line 249 "../src/grid.vala"
											break;
#line 1214 "grid.c"
										}
#line 251 "../src/grid.vala"
										_tmp13_ = cur;
#line 251 "../src/grid.vala"
										_tmp14_ = (*grid)[(_tmp13_.row * (*grid_length2)) + k];
#line 251 "../src/grid.vala"
										k_val = _tmp14_;
#line 253 "../src/grid.vala"
										if (((gint) k_val) != 0) {
#line 255 "../src/grid.vala"
											if (k_val == val) {
#line 1226 "grid.c"
												GridPosition _tmp15_;
												GridPosition _tmp16_ = {0};
#line 257 "../src/grid.vala"
												has_match = TRUE;
#line 258 "../src/grid.vala"
												_tmp15_ = cur;
#line 258 "../src/grid.vala"
												_tmp16_.row = _tmp15_.row;
#line 258 "../src/grid.vala"
												_tmp16_.col = k;
#line 258 "../src/grid.vala"
												match = _tmp16_;
#line 1239 "grid.c"
											}
#line 260 "../src/grid.vala"
											break;
#line 1243 "grid.c"
										}
									}
								}
							}
#line 264 "../src/grid.vala"
							if (has_match) {
#line 1250 "grid.c"
								GridPosition _tmp17_;
								gint8 _tmp18_;
#line 266 "../src/grid.vala"
								_tmp17_ = free;
#line 266 "../src/grid.vala"
								if (((gint) _tmp17_.col) == -1) {
#line 267 "../src/grid.vala"
									free.col = col;
#line 1259 "grid.c"
								}
#line 269 "../src/grid.vala"
								_grid_move_to_match (to_hide, to_show, &cur, &free, &match, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val, max_changed);
#line 270 "../src/grid.vala"
								_tmp18_ = free.col;
#line 270 "../src/grid.vala"
								free.col = _tmp18_ + 1;
#line 1267 "grid.c"
							} else {
								GridPosition _tmp19_;
#line 272 "../src/grid.vala"
								_tmp19_ = free;
#line 272 "../src/grid.vala"
								if (((gint) _tmp19_.col) != -1) {
#line 1274 "grid.c"
									gint8 _tmp20_;
#line 274 "../src/grid.vala"
									_grid_move_to_end (to_move, &cur, &free, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val);
#line 275 "../src/grid.vala"
									_tmp20_ = free.col;
#line 275 "../src/grid.vala"
									free.col = _tmp20_ + 1;
#line 1282 "grid.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
_grid_move_right (gint8 cols,
                  gint8 rows,
                  guint8* max_changed,
                  guint8** grid,
                  gint* grid_length1,
                  gint* grid_length2,
                  GeeLinkedList** to_move,
                  GeeLinkedList** to_hide,
                  GeeLinkedList** to_show)
{
#line 281 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 281 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 281 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 1310 "grid.c"
	{
		gint8 i = 0;
#line 289 "../src/grid.vala"
		i = (gint8) 0;
#line 1315 "grid.c"
		{
			gboolean _tmp0_ = FALSE;
#line 289 "../src/grid.vala"
			_tmp0_ = TRUE;
#line 289 "../src/grid.vala"
			while (TRUE) {
#line 1322 "grid.c"
				GridPosition free = {0};
				GridPosition _tmp2_ = {0};
#line 289 "../src/grid.vala"
				if (!_tmp0_) {
#line 1327 "grid.c"
					gint8 _tmp1_;
#line 289 "../src/grid.vala"
					_tmp1_ = i;
#line 289 "../src/grid.vala"
					i = _tmp1_ + 1;
#line 1333 "grid.c"
				}
#line 289 "../src/grid.vala"
				_tmp0_ = FALSE;
#line 289 "../src/grid.vala"
				if (!(i < rows)) {
#line 289 "../src/grid.vala"
					break;
#line 1341 "grid.c"
				}
#line 291 "../src/grid.vala"
				_tmp2_.row = i;
#line 291 "../src/grid.vala"
				_tmp2_.col = cols;
#line 291 "../src/grid.vala"
				free = _tmp2_;
#line 1349 "grid.c"
				{
					gint8 j = 0;
#line 293 "../src/grid.vala"
					j = (gint8) 0;
#line 1354 "grid.c"
					{
						gboolean _tmp3_ = FALSE;
#line 293 "../src/grid.vala"
						_tmp3_ = TRUE;
#line 293 "../src/grid.vala"
						while (TRUE) {
#line 1361 "grid.c"
							gint8 col = 0;
							GridPosition cur = {0};
							GridPosition _tmp5_ = {0};
							guint8 val = 0U;
							GridPosition _tmp6_;
							GridPosition _tmp7_;
							guint8 _tmp8_;
							GridPosition match = {0};
							GridPosition _tmp10_ = {0};
							gboolean has_match = FALSE;
#line 293 "../src/grid.vala"
							if (!_tmp3_) {
#line 1374 "grid.c"
								gint8 _tmp4_;
#line 293 "../src/grid.vala"
								_tmp4_ = j;
#line 293 "../src/grid.vala"
								j = _tmp4_ + 1;
#line 1380 "grid.c"
							}
#line 293 "../src/grid.vala"
							_tmp3_ = FALSE;
#line 293 "../src/grid.vala"
							if (!(j < cols)) {
#line 293 "../src/grid.vala"
								break;
#line 1388 "grid.c"
							}
#line 295 "../src/grid.vala"
							col = (gint8) ((cols - j) - 1);
#line 296 "../src/grid.vala"
							_tmp5_.row = i;
#line 296 "../src/grid.vala"
							_tmp5_.col = col;
#line 296 "../src/grid.vala"
							cur = _tmp5_;
#line 297 "../src/grid.vala"
							_tmp6_ = cur;
#line 297 "../src/grid.vala"
							_tmp7_ = cur;
#line 297 "../src/grid.vala"
							_tmp8_ = (*grid)[(_tmp6_.row * (*grid_length2)) + _tmp7_.col];
#line 297 "../src/grid.vala"
							val = _tmp8_;
#line 299 "../src/grid.vala"
							if (((gint) val) == 0) {
#line 1408 "grid.c"
								GridPosition _tmp9_;
#line 301 "../src/grid.vala"
								_tmp9_ = free;
#line 301 "../src/grid.vala"
								if (_tmp9_.col == cols) {
#line 302 "../src/grid.vala"
									free.col = col;
#line 1416 "grid.c"
								}
#line 303 "../src/grid.vala"
								continue;
#line 1420 "grid.c"
							}
#line 307 "../src/grid.vala"
							_tmp10_.row = (gint8) 0;
#line 307 "../src/grid.vala"
							_tmp10_.col = (gint8) 0;
#line 307 "../src/grid.vala"
							match = _tmp10_;
#line 308 "../src/grid.vala"
							has_match = FALSE;
#line 1430 "grid.c"
							{
								gint8 k = 0;
#line 309 "../src/grid.vala"
								k = (gint8) (col - 1);
#line 1435 "grid.c"
								{
									gboolean _tmp11_ = FALSE;
#line 309 "../src/grid.vala"
									_tmp11_ = TRUE;
#line 309 "../src/grid.vala"
									while (TRUE) {
#line 1442 "grid.c"
										guint8 k_val = 0U;
										GridPosition _tmp13_;
										guint8 _tmp14_;
#line 309 "../src/grid.vala"
										if (!_tmp11_) {
#line 1448 "grid.c"
											gint8 _tmp12_;
#line 309 "../src/grid.vala"
											_tmp12_ = k;
#line 309 "../src/grid.vala"
											k = _tmp12_ - 1;
#line 1454 "grid.c"
										}
#line 309 "../src/grid.vala"
										_tmp11_ = FALSE;
#line 309 "../src/grid.vala"
										if (!(((gint) k) >= 0)) {
#line 309 "../src/grid.vala"
											break;
#line 1462 "grid.c"
										}
#line 311 "../src/grid.vala"
										_tmp13_ = cur;
#line 311 "../src/grid.vala"
										_tmp14_ = (*grid)[(_tmp13_.row * (*grid_length2)) + k];
#line 311 "../src/grid.vala"
										k_val = _tmp14_;
#line 313 "../src/grid.vala"
										if (((gint) k_val) != 0) {
#line 315 "../src/grid.vala"
											if (k_val == val) {
#line 1474 "grid.c"
												GridPosition _tmp15_;
												GridPosition _tmp16_ = {0};
#line 317 "../src/grid.vala"
												has_match = TRUE;
#line 318 "../src/grid.vala"
												_tmp15_ = cur;
#line 318 "../src/grid.vala"
												_tmp16_.row = _tmp15_.row;
#line 318 "../src/grid.vala"
												_tmp16_.col = k;
#line 318 "../src/grid.vala"
												match = _tmp16_;
#line 1487 "grid.c"
											}
#line 320 "../src/grid.vala"
											break;
#line 1491 "grid.c"
										}
									}
								}
							}
#line 324 "../src/grid.vala"
							if (has_match) {
#line 1498 "grid.c"
								GridPosition _tmp17_;
								gint8 _tmp18_;
#line 326 "../src/grid.vala"
								_tmp17_ = free;
#line 326 "../src/grid.vala"
								if (_tmp17_.col == cols) {
#line 327 "../src/grid.vala"
									free.col = col;
#line 1507 "grid.c"
								}
#line 329 "../src/grid.vala"
								_grid_move_to_match (to_hide, to_show, &cur, &free, &match, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val, max_changed);
#line 330 "../src/grid.vala"
								_tmp18_ = free.col;
#line 330 "../src/grid.vala"
								free.col = _tmp18_ - 1;
#line 1515 "grid.c"
							} else {
								GridPosition _tmp19_;
#line 332 "../src/grid.vala"
								_tmp19_ = free;
#line 332 "../src/grid.vala"
								if (_tmp19_.col != cols) {
#line 1522 "grid.c"
									gint8 _tmp20_;
#line 334 "../src/grid.vala"
									_grid_move_to_end (to_move, &cur, &free, grid, (gint*) (grid_length1), (gint*) (grid_length2), &val);
#line 335 "../src/grid.vala"
									_tmp20_ = free.col;
#line 335 "../src/grid.vala"
									free.col = _tmp20_ - 1;
#line 1530 "grid.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
_grid_move_to_match (GeeLinkedList** to_hide,
                     GeeLinkedList** to_show,
                     GridPosition* cur,
                     GridPosition* free,
                     GridPosition* match,
                     guint8** grid,
                     gint* grid_length1,
                     gint* grid_length2,
                     guint8* val,
                     guint8* max_changed)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	TileMovement mov = {0};
	GridPosition _tmp4_;
	GridPosition _tmp5_;
	TileMovement _tmp6_ = {0};
	TileMovement _tmp7_;
	GridPosition _tmp8_;
	GridPosition _tmp9_;
	TileMovement _tmp10_ = {0};
	TileMovement _tmp11_;
	guint8 _tmp12_;
	Tile tile = {0};
	GridPosition _tmp13_;
	Tile _tmp14_ = {0};
	Tile _tmp15_;
	GridPosition _tmp16_;
	GridPosition _tmp17_;
	GridPosition _tmp18_;
	GridPosition _tmp19_;
	GridPosition _tmp20_;
	GridPosition _tmp21_;
#line 345 "../src/grid.vala"
	g_return_if_fail (*to_hide != NULL);
#line 345 "../src/grid.vala"
	g_return_if_fail (*to_show != NULL);
#line 345 "../src/grid.vala"
	g_return_if_fail (cur != NULL);
#line 345 "../src/grid.vala"
	g_return_if_fail (free != NULL);
#line 345 "../src/grid.vala"
	g_return_if_fail (match != NULL);
#line 354 "../src/grid.vala"
	_tmp0_ = grid_position_to_string (match);
#line 354 "../src/grid.vala"
	_tmp1_ = _tmp0_;
#line 354 "../src/grid.vala"
	_tmp2_ = g_strconcat ("matching tile found at ", _tmp1_, NULL);
#line 354 "../src/grid.vala"
	_tmp3_ = _tmp2_;
#line 354 "../src/grid.vala"
	g_debug ("grid.vala:354: %s", _tmp3_);
#line 354 "../src/grid.vala"
	_g_free0 (_tmp3_);
#line 354 "../src/grid.vala"
	_g_free0 (_tmp1_);
#line 356 "../src/grid.vala"
	_tmp4_ = *cur;
#line 356 "../src/grid.vala"
	_tmp5_ = *free;
#line 356 "../src/grid.vala"
	_tmp6_.from = _tmp4_;
#line 356 "../src/grid.vala"
	_tmp6_.to = _tmp5_;
#line 356 "../src/grid.vala"
	mov = _tmp6_;
#line 357 "../src/grid.vala"
	_tmp7_ = mov;
#line 357 "../src/grid.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) (*to_hide), &_tmp7_);
#line 358 "../src/grid.vala"
	_tmp8_ = *match;
#line 358 "../src/grid.vala"
	_tmp9_ = *free;
#line 358 "../src/grid.vala"
	_tmp10_.from = _tmp8_;
#line 358 "../src/grid.vala"
	_tmp10_.to = _tmp9_;
#line 358 "../src/grid.vala"
	mov = _tmp10_;
#line 359 "../src/grid.vala"
	_tmp11_ = mov;
#line 359 "../src/grid.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) (*to_hide), &_tmp11_);
#line 361 "../src/grid.vala"
	_tmp12_ = *val;
#line 361 "../src/grid.vala"
	*val = _tmp12_ + 1;
#line 362 "../src/grid.vala"
	_tmp13_ = *free;
#line 362 "../src/grid.vala"
	_tmp14_.pos = _tmp13_;
#line 362 "../src/grid.vala"
	_tmp14_.val = *val;
#line 362 "../src/grid.vala"
	tile = _tmp14_;
#line 363 "../src/grid.vala"
	_tmp15_ = tile;
#line 363 "../src/grid.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) (*to_show), &_tmp15_);
#line 365 "../src/grid.vala"
	_tmp16_ = *cur;
#line 365 "../src/grid.vala"
	_tmp17_ = *cur;
#line 365 "../src/grid.vala"
	(*grid)[(_tmp16_.row * (*grid_length2)) + _tmp17_.col] = (guint8) 0;
#line 366 "../src/grid.vala"
	_tmp18_ = *match;
#line 366 "../src/grid.vala"
	_tmp19_ = *match;
#line 366 "../src/grid.vala"
	(*grid)[(_tmp18_.row * (*grid_length2)) + _tmp19_.col] = (guint8) 0;
#line 367 "../src/grid.vala"
	_tmp20_ = *free;
#line 367 "../src/grid.vala"
	_tmp21_ = *free;
#line 367 "../src/grid.vala"
	(*grid)[(_tmp20_.row * (*grid_length2)) + _tmp21_.col] = *val;
#line 368 "../src/grid.vala"
	if ((*max_changed) < (*val)) {
#line 369 "../src/grid.vala"
		*max_changed = *val;
#line 1667 "grid.c"
	}
}

static void
_grid_move_to_end (GeeLinkedList** to_move,
                   GridPosition* cur,
                   GridPosition* free,
                   guint8** grid,
                   gint* grid_length1,
                   gint* grid_length2,
                   guint8* val)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	TileMovement mov = {0};
	GridPosition _tmp6_;
	GridPosition _tmp7_;
	TileMovement _tmp8_ = {0};
	TileMovement _tmp9_;
	GridPosition _tmp10_;
	GridPosition _tmp11_;
	GridPosition _tmp12_;
	GridPosition _tmp13_;
#line 372 "../src/grid.vala"
	g_return_if_fail (*to_move != NULL);
#line 372 "../src/grid.vala"
	g_return_if_fail (cur != NULL);
#line 372 "../src/grid.vala"
	g_return_if_fail (free != NULL);
#line 378 "../src/grid.vala"
	_tmp0_ = grid_position_to_string (cur);
#line 378 "../src/grid.vala"
	_tmp1_ = _tmp0_;
#line 378 "../src/grid.vala"
	_tmp2_ = grid_position_to_string (free);
#line 378 "../src/grid.vala"
	_tmp3_ = _tmp2_;
#line 378 "../src/grid.vala"
	_tmp4_ = g_strconcat ("moving ", _tmp1_, " to ", _tmp3_, NULL);
#line 378 "../src/grid.vala"
	_tmp5_ = _tmp4_;
#line 378 "../src/grid.vala"
	g_debug ("grid.vala:378: %s", _tmp5_);
#line 378 "../src/grid.vala"
	_g_free0 (_tmp5_);
#line 378 "../src/grid.vala"
	_g_free0 (_tmp3_);
#line 378 "../src/grid.vala"
	_g_free0 (_tmp1_);
#line 380 "../src/grid.vala"
	_tmp6_ = *cur;
#line 380 "../src/grid.vala"
	_tmp7_ = *free;
#line 380 "../src/grid.vala"
	_tmp8_.from = _tmp6_;
#line 380 "../src/grid.vala"
	_tmp8_.to = _tmp7_;
#line 380 "../src/grid.vala"
	mov = _tmp8_;
#line 381 "../src/grid.vala"
	_tmp9_ = mov;
#line 381 "../src/grid.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) (*to_move), &_tmp9_);
#line 383 "../src/grid.vala"
	_tmp10_ = *cur;
#line 383 "../src/grid.vala"
	_tmp11_ = *cur;
#line 383 "../src/grid.vala"
	(*grid)[(_tmp10_.row * (*grid_length2)) + _tmp11_.col] = (guint8) 0;
#line 384 "../src/grid.vala"
	_tmp12_ = *free;
#line 384 "../src/grid.vala"
	_tmp13_ = *free;
#line 384 "../src/grid.vala"
	(*grid)[(_tmp12_.row * (*grid_length2)) + _tmp13_.col] = *val;
#line 1747 "grid.c"
}

gboolean
grid_is_finished (Grid* self)
{
	gboolean _tmp0_;
	gboolean result;
#line 391 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 393 "../src/grid.vala"
	_tmp0_ = _grid_grid_is_full (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 393 "../src/grid.vala"
	if (!_tmp0_) {
#line 394 "../src/grid.vala"
		result = FALSE;
#line 394 "../src/grid.vala"
		return result;
#line 1765 "grid.c"
	}
	{
		guint8 i = 0U;
#line 396 "../src/grid.vala"
		i = (guint8) 0;
#line 1771 "grid.c"
		{
			gboolean _tmp1_ = FALSE;
#line 396 "../src/grid.vala"
			_tmp1_ = TRUE;
#line 396 "../src/grid.vala"
			while (TRUE) {
#line 396 "../src/grid.vala"
				if (!_tmp1_) {
#line 1780 "grid.c"
					guint8 _tmp2_;
#line 396 "../src/grid.vala"
					_tmp2_ = i;
#line 396 "../src/grid.vala"
					i = _tmp2_ + 1;
#line 1786 "grid.c"
				}
#line 396 "../src/grid.vala"
				_tmp1_ = FALSE;
#line 396 "../src/grid.vala"
				if (!(i < self->priv->_rows)) {
#line 396 "../src/grid.vala"
					break;
#line 1794 "grid.c"
				}
				{
					guint8 j = 0U;
#line 398 "../src/grid.vala"
					j = (guint8) 0;
#line 1800 "grid.c"
					{
						gboolean _tmp3_ = FALSE;
#line 398 "../src/grid.vala"
						_tmp3_ = TRUE;
#line 398 "../src/grid.vala"
						while (TRUE) {
#line 1807 "grid.c"
							guint8 val = 0U;
							guint8* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							guint8 _tmp6_;
							gboolean _tmp7_ = FALSE;
							gboolean _tmp10_ = FALSE;
#line 398 "../src/grid.vala"
							if (!_tmp3_) {
#line 1817 "grid.c"
								guint8 _tmp4_;
#line 398 "../src/grid.vala"
								_tmp4_ = j;
#line 398 "../src/grid.vala"
								j = _tmp4_ + 1;
#line 1823 "grid.c"
							}
#line 398 "../src/grid.vala"
							_tmp3_ = FALSE;
#line 398 "../src/grid.vala"
							if (!(j < self->priv->_cols)) {
#line 398 "../src/grid.vala"
								break;
#line 1831 "grid.c"
							}
#line 400 "../src/grid.vala"
							_tmp5_ = self->_grid;
#line 400 "../src/grid.vala"
							_tmp5__length1 = self->_grid_length1;
#line 400 "../src/grid.vala"
							_tmp5__length2 = self->_grid_length2;
#line 400 "../src/grid.vala"
							_tmp6_ = _tmp5_[(i * _tmp5__length2) + j];
#line 400 "../src/grid.vala"
							val = _tmp6_;
#line 402 "../src/grid.vala"
							if (((gint) i) < (self->priv->_rows - 1)) {
#line 1845 "grid.c"
								guint8* _tmp8_;
								gint _tmp8__length1;
								gint _tmp8__length2;
								guint8 _tmp9_;
#line 402 "../src/grid.vala"
								_tmp8_ = self->_grid;
#line 402 "../src/grid.vala"
								_tmp8__length1 = self->_grid_length1;
#line 402 "../src/grid.vala"
								_tmp8__length2 = self->_grid_length2;
#line 402 "../src/grid.vala"
								_tmp9_ = _tmp8_[((i + 1) * _tmp8__length2) + j];
#line 402 "../src/grid.vala"
								_tmp7_ = val == _tmp9_;
#line 1860 "grid.c"
							} else {
#line 402 "../src/grid.vala"
								_tmp7_ = FALSE;
#line 1864 "grid.c"
							}
#line 402 "../src/grid.vala"
							if (_tmp7_) {
#line 403 "../src/grid.vala"
								result = FALSE;
#line 403 "../src/grid.vala"
								return result;
#line 1872 "grid.c"
							}
#line 405 "../src/grid.vala"
							if (((gint) j) < (self->priv->_cols - 1)) {
#line 1876 "grid.c"
								guint8* _tmp11_;
								gint _tmp11__length1;
								gint _tmp11__length2;
								guint8 _tmp12_;
#line 405 "../src/grid.vala"
								_tmp11_ = self->_grid;
#line 405 "../src/grid.vala"
								_tmp11__length1 = self->_grid_length1;
#line 405 "../src/grid.vala"
								_tmp11__length2 = self->_grid_length2;
#line 405 "../src/grid.vala"
								_tmp12_ = _tmp11_[(i * _tmp11__length2) + (j + 1)];
#line 405 "../src/grid.vala"
								_tmp10_ = val == _tmp12_;
#line 1891 "grid.c"
							} else {
#line 405 "../src/grid.vala"
								_tmp10_ = FALSE;
#line 1895 "grid.c"
							}
#line 405 "../src/grid.vala"
							if (_tmp10_) {
#line 406 "../src/grid.vala"
								result = FALSE;
#line 406 "../src/grid.vala"
								return result;
#line 1903 "grid.c"
							}
						}
					}
				}
			}
		}
	}
#line 410 "../src/grid.vala"
	result = TRUE;
#line 410 "../src/grid.vala"
	return result;
#line 1915 "grid.c"
}

gboolean
_grid_grid_is_full (guint8** grid,
                    gint* grid_length1,
                    gint* grid_length2)
{
	guint rows = 0U;
	gint _tmp0_;
	guint cols = 0U;
	gint _tmp1_;
	gboolean result;
#line 415 "../src/grid.vala"
	_tmp0_ = *grid_length1;
#line 415 "../src/grid.vala"
	rows = (guint) _tmp0_;
#line 416 "../src/grid.vala"
	_tmp1_ = *grid_length2;
#line 416 "../src/grid.vala"
	cols = (guint) _tmp1_;
#line 1936 "grid.c"
	{
		guint i = 0U;
#line 418 "../src/grid.vala"
		i = (guint) 0;
#line 1941 "grid.c"
		{
			gboolean _tmp2_ = FALSE;
#line 418 "../src/grid.vala"
			_tmp2_ = TRUE;
#line 418 "../src/grid.vala"
			while (TRUE) {
#line 418 "../src/grid.vala"
				if (!_tmp2_) {
#line 1950 "grid.c"
					guint _tmp3_;
#line 418 "../src/grid.vala"
					_tmp3_ = i;
#line 418 "../src/grid.vala"
					i = _tmp3_ + 1;
#line 1956 "grid.c"
				}
#line 418 "../src/grid.vala"
				_tmp2_ = FALSE;
#line 418 "../src/grid.vala"
				if (!(i < rows)) {
#line 418 "../src/grid.vala"
					break;
#line 1964 "grid.c"
				}
				{
					guint j = 0U;
#line 419 "../src/grid.vala"
					j = (guint) 0;
#line 1970 "grid.c"
					{
						gboolean _tmp4_ = FALSE;
#line 419 "../src/grid.vala"
						_tmp4_ = TRUE;
#line 419 "../src/grid.vala"
						while (TRUE) {
#line 1977 "grid.c"
							guint8 _tmp6_;
#line 419 "../src/grid.vala"
							if (!_tmp4_) {
#line 1981 "grid.c"
								guint _tmp5_;
#line 419 "../src/grid.vala"
								_tmp5_ = j;
#line 419 "../src/grid.vala"
								j = _tmp5_ + 1;
#line 1987 "grid.c"
							}
#line 419 "../src/grid.vala"
							_tmp4_ = FALSE;
#line 419 "../src/grid.vala"
							if (!(j < cols)) {
#line 419 "../src/grid.vala"
								break;
#line 1995 "grid.c"
							}
#line 420 "../src/grid.vala"
							_tmp6_ = (*grid)[(i * (*grid_length2)) + j];
#line 420 "../src/grid.vala"
							if (((gint) _tmp6_) == 0) {
#line 421 "../src/grid.vala"
								result = FALSE;
#line 421 "../src/grid.vala"
								return result;
#line 2005 "grid.c"
							}
						}
					}
				}
			}
		}
	}
#line 422 "../src/grid.vala"
	result = TRUE;
#line 422 "../src/grid.vala"
	return result;
#line 2017 "grid.c"
}

void
grid_clear (Grid* self)
{
#line 425 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 427 "../src/grid.vala"
	_grid_clear (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 2027 "grid.c"
}

static void
_grid_clear (guint8** grid,
             gint* grid_length1,
             gint* grid_length2)
{
	guint rows = 0U;
	gint _tmp0_;
	guint cols = 0U;
	gint _tmp1_;
#line 431 "../src/grid.vala"
	_tmp0_ = *grid_length1;
#line 431 "../src/grid.vala"
	rows = (guint) _tmp0_;
#line 432 "../src/grid.vala"
	_tmp1_ = *grid_length2;
#line 432 "../src/grid.vala"
	cols = (guint) _tmp1_;
#line 2047 "grid.c"
	{
		guint i = 0U;
#line 434 "../src/grid.vala"
		i = (guint) 0;
#line 2052 "grid.c"
		{
			gboolean _tmp2_ = FALSE;
#line 434 "../src/grid.vala"
			_tmp2_ = TRUE;
#line 434 "../src/grid.vala"
			while (TRUE) {
#line 434 "../src/grid.vala"
				if (!_tmp2_) {
#line 2061 "grid.c"
					guint _tmp3_;
#line 434 "../src/grid.vala"
					_tmp3_ = i;
#line 434 "../src/grid.vala"
					i = _tmp3_ + 1;
#line 2067 "grid.c"
				}
#line 434 "../src/grid.vala"
				_tmp2_ = FALSE;
#line 434 "../src/grid.vala"
				if (!(i < rows)) {
#line 434 "../src/grid.vala"
					break;
#line 2075 "grid.c"
				}
				{
					guint j = 0U;
#line 435 "../src/grid.vala"
					j = (guint) 0;
#line 2081 "grid.c"
					{
						gboolean _tmp4_ = FALSE;
#line 435 "../src/grid.vala"
						_tmp4_ = TRUE;
#line 435 "../src/grid.vala"
						while (TRUE) {
#line 435 "../src/grid.vala"
							if (!_tmp4_) {
#line 2090 "grid.c"
								guint _tmp5_;
#line 435 "../src/grid.vala"
								_tmp5_ = j;
#line 435 "../src/grid.vala"
								j = _tmp5_ + 1;
#line 2096 "grid.c"
							}
#line 435 "../src/grid.vala"
							_tmp4_ = FALSE;
#line 435 "../src/grid.vala"
							if (!(j < cols)) {
#line 435 "../src/grid.vala"
								break;
#line 2104 "grid.c"
							}
#line 436 "../src/grid.vala"
							(*grid)[(i * (*grid_length2)) + j] = (guint8) 0;
#line 2108 "grid.c"
						}
					}
				}
			}
		}
	}
}

glong
grid_get_score (Grid* self)
{
	glong _tmp0_;
	glong result;
#line 439 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0L);
#line 441 "../src/grid.vala"
	_tmp0_ = _grid_get_score (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 441 "../src/grid.vala"
	result = _tmp0_;
#line 441 "../src/grid.vala"
	return result;
#line 2130 "grid.c"
}

static glong
_grid_get_score (guint8** grid,
                 gint* grid_length1,
                 gint* grid_length2)
{
	glong score = 0L;
	guint rows = 0U;
	gint _tmp0_;
	guint cols = 0U;
	gint _tmp1_;
	glong result;
#line 445 "../src/grid.vala"
	score = (glong) 0;
#line 447 "../src/grid.vala"
	_tmp0_ = *grid_length1;
#line 447 "../src/grid.vala"
	rows = (guint) _tmp0_;
#line 448 "../src/grid.vala"
	_tmp1_ = *grid_length2;
#line 448 "../src/grid.vala"
	cols = (guint) _tmp1_;
#line 2154 "grid.c"
	{
		guint i = 0U;
#line 450 "../src/grid.vala"
		i = (guint) 0;
#line 2159 "grid.c"
		{
			gboolean _tmp2_ = FALSE;
#line 450 "../src/grid.vala"
			_tmp2_ = TRUE;
#line 450 "../src/grid.vala"
			while (TRUE) {
#line 450 "../src/grid.vala"
				if (!_tmp2_) {
#line 2168 "grid.c"
					guint _tmp3_;
#line 450 "../src/grid.vala"
					_tmp3_ = i;
#line 450 "../src/grid.vala"
					i = _tmp3_ + 1;
#line 2174 "grid.c"
				}
#line 450 "../src/grid.vala"
				_tmp2_ = FALSE;
#line 450 "../src/grid.vala"
				if (!(i < rows)) {
#line 450 "../src/grid.vala"
					break;
#line 2182 "grid.c"
				}
				{
					guint j = 0U;
#line 451 "../src/grid.vala"
					j = (guint) 0;
#line 2188 "grid.c"
					{
						gboolean _tmp4_ = FALSE;
#line 451 "../src/grid.vala"
						_tmp4_ = TRUE;
#line 451 "../src/grid.vala"
						while (TRUE) {
#line 2195 "grid.c"
							guint8 _tmp6_;
#line 451 "../src/grid.vala"
							if (!_tmp4_) {
#line 2199 "grid.c"
								guint _tmp5_;
#line 451 "../src/grid.vala"
								_tmp5_ = j;
#line 451 "../src/grid.vala"
								j = _tmp5_ + 1;
#line 2205 "grid.c"
							}
#line 451 "../src/grid.vala"
							_tmp4_ = FALSE;
#line 451 "../src/grid.vala"
							if (!(j < cols)) {
#line 451 "../src/grid.vala"
								break;
#line 2213 "grid.c"
							}
#line 452 "../src/grid.vala"
							_tmp6_ = (*grid)[(i * (*grid_length2)) + j];
#line 452 "../src/grid.vala"
							score += _grid_calculate_score_value (_tmp6_);
#line 2219 "grid.c"
						}
					}
				}
			}
		}
	}
#line 453 "../src/grid.vala"
	result = score;
#line 453 "../src/grid.vala"
	return result;
#line 2230 "grid.c"
}

static inline glong
_grid_calculate_score_value (guint8 tile_value)
{
	glong result;
#line 457 "../src/grid.vala"
	if (((gint) tile_value) < 2) {
#line 458 "../src/grid.vala"
		result = (glong) 0;
#line 458 "../src/grid.vala"
		return result;
#line 2243 "grid.c"
	}
#line 459 "../src/grid.vala"
	result = (glong) (pow ((gdouble) 2, (gdouble) tile_value) * (tile_value - 1));
#line 459 "../src/grid.vala"
	return result;
#line 2249 "grid.c"
}

static guint8*
_vala_array_dup1 (guint8* self,
                  gssize length)
{
#line 469 "../src/grid.vala"
	if (length > 0) {
#line 469 "../src/grid.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 2260 "grid.c"
	}
#line 469 "../src/grid.vala"
	return NULL;
#line 2264 "grid.c"
}

Grid*
grid_clone (Grid* self)
{
	Grid* grid = NULL;
	Grid* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Grid* result;
#line 466 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 468 "../src/grid.vala"
	_tmp0_ = grid_new (self->priv->_rows, self->priv->_cols);
#line 468 "../src/grid.vala"
	grid = _tmp0_;
#line 469 "../src/grid.vala"
	_tmp1_ = self->_grid;
#line 469 "../src/grid.vala"
	_tmp1__length1 = self->_grid_length1;
#line 469 "../src/grid.vala"
	_tmp1__length2 = self->_grid_length2;
#line 469 "../src/grid.vala"
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup1 (_tmp1_, _tmp1__length1 * _tmp1__length2) : _tmp1_;
#line 469 "../src/grid.vala"
	_tmp2__length1 = _tmp1__length1;
#line 469 "../src/grid.vala"
	_tmp2__length2 = _tmp1__length2;
#line 469 "../src/grid.vala"
	grid->_grid = (g_free (grid->_grid), NULL);
#line 469 "../src/grid.vala"
	grid->_grid = _tmp2_;
#line 469 "../src/grid.vala"
	grid->_grid_length1 = _tmp2__length1;
#line 469 "../src/grid.vala"
	grid->_grid_length2 = _tmp2__length2;
#line 470 "../src/grid.vala"
	grid->priv->_target_value = self->priv->_target_value;
#line 471 "../src/grid.vala"
	grid->priv->_target_value_reached = self->priv->_target_value_reached;
#line 473 "../src/grid.vala"
	result = grid;
#line 473 "../src/grid.vala"
	return result;
#line 2313 "grid.c"
}

guint8
grid_get (Grid* self,
          guint8 row,
          guint8 col)
{
	gboolean _tmp0_ = FALSE;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	guint8 _tmp2_;
	guint8 result;
#line 476 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 478 "../src/grid.vala"
	if (row >= self->priv->_rows) {
#line 478 "../src/grid.vala"
		_tmp0_ = TRUE;
#line 2333 "grid.c"
	} else {
#line 478 "../src/grid.vala"
		_tmp0_ = col >= self->priv->_cols;
#line 2337 "grid.c"
	}
#line 478 "../src/grid.vala"
	if (_tmp0_) {
#line 479 "../src/grid.vala"
		result = (guint8) 0;
#line 479 "../src/grid.vala"
		return result;
#line 2345 "grid.c"
	}
#line 481 "../src/grid.vala"
	_tmp1_ = self->_grid;
#line 481 "../src/grid.vala"
	_tmp1__length1 = self->_grid_length1;
#line 481 "../src/grid.vala"
	_tmp1__length2 = self->_grid_length2;
#line 481 "../src/grid.vala"
	_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 481 "../src/grid.vala"
	result = _tmp2_;
#line 481 "../src/grid.vala"
	return result;
#line 2359 "grid.c"
}

gboolean
grid_is_disallowed_grid_size (guint8* rows,
                              guint8* cols)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 484 "../src/grid.vala"
	_vala_return_val_if_fail (((gint) (*rows)) >= 1, "rows >= 1", FALSE);
#line 484 "../src/grid.vala"
	_vala_return_val_if_fail (((gint) (*rows)) <= 9, "rows <= 9", FALSE);
#line 484 "../src/grid.vala"
	_vala_return_val_if_fail (((gint) (*cols)) >= 1, "cols >= 1", FALSE);
#line 484 "../src/grid.vala"
	_vala_return_val_if_fail (((gint) (*cols)) <= 9, "cols <= 9", FALSE);
#line 490 "../src/grid.vala"
	if (((gint) (*rows)) == 1) {
#line 490 "../src/grid.vala"
		_tmp2_ = ((gint) (*cols)) == 1;
#line 2382 "grid.c"
	} else {
#line 490 "../src/grid.vala"
		_tmp2_ = FALSE;
#line 2386 "grid.c"
	}
#line 490 "../src/grid.vala"
	if (_tmp2_) {
#line 490 "../src/grid.vala"
		_tmp1_ = TRUE;
#line 2392 "grid.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 490 "../src/grid.vala"
		if (((gint) (*rows)) == 1) {
#line 490 "../src/grid.vala"
			_tmp3_ = ((gint) (*cols)) == 2;
#line 2399 "grid.c"
		} else {
#line 490 "../src/grid.vala"
			_tmp3_ = FALSE;
#line 2403 "grid.c"
		}
#line 490 "../src/grid.vala"
		_tmp1_ = _tmp3_;
#line 2407 "grid.c"
	}
#line 490 "../src/grid.vala"
	if (_tmp1_) {
#line 490 "../src/grid.vala"
		_tmp0_ = TRUE;
#line 2413 "grid.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 490 "../src/grid.vala"
		if (((gint) (*rows)) == 2) {
#line 490 "../src/grid.vala"
			_tmp4_ = ((gint) (*cols)) == 1;
#line 2420 "grid.c"
		} else {
#line 490 "../src/grid.vala"
			_tmp4_ = FALSE;
#line 2424 "grid.c"
		}
#line 490 "../src/grid.vala"
		_tmp0_ = _tmp4_;
#line 2428 "grid.c"
	}
#line 490 "../src/grid.vala"
	result = _tmp0_;
#line 490 "../src/grid.vala"
	return result;
#line 2434 "grid.c"
}

gchar*
grid_save (Grid* self)
{
	gchar* ret_string = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	glong _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* result;
#line 497 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 499 "../src/grid.vala"
	_tmp0_ = g_strdup_printf ("%hhu", self->priv->_rows);
#line 499 "../src/grid.vala"
	_tmp1_ = _tmp0_;
#line 499 "../src/grid.vala"
	_tmp2_ = g_strdup_printf ("%hhu", self->priv->_cols);
#line 499 "../src/grid.vala"
	_tmp3_ = _tmp2_;
#line 499 "../src/grid.vala"
	_tmp4_ = g_strconcat (_tmp1_, " ", _tmp3_, "\n", NULL);
#line 499 "../src/grid.vala"
	_tmp5_ = _tmp4_;
#line 499 "../src/grid.vala"
	_g_free0 (_tmp3_);
#line 499 "../src/grid.vala"
	_g_free0 (_tmp1_);
#line 499 "../src/grid.vala"
	ret_string = _tmp5_;
#line 500 "../src/grid.vala"
	_grid_convert_to_string (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), &ret_string);
#line 501 "../src/grid.vala"
	_tmp6_ = ret_string;
#line 501 "../src/grid.vala"
	_tmp7_ = _grid_get_score (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 501 "../src/grid.vala"
	_tmp8_ = g_strdup_printf ("%li", _tmp7_);
#line 501 "../src/grid.vala"
	_tmp9_ = _tmp8_;
#line 501 "../src/grid.vala"
	_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 501 "../src/grid.vala"
	_g_free0 (ret_string);
#line 501 "../src/grid.vala"
	ret_string = _tmp10_;
#line 501 "../src/grid.vala"
	_g_free0 (_tmp9_);
#line 502 "../src/grid.vala"
	_tmp11_ = ret_string;
#line 502 "../src/grid.vala"
	_tmp12_ = g_strconcat (_tmp11_, "\n", NULL);
#line 502 "../src/grid.vala"
	_g_free0 (ret_string);
#line 502 "../src/grid.vala"
	ret_string = _tmp12_;
#line 503 "../src/grid.vala"
	result = ret_string;
#line 503 "../src/grid.vala"
	return result;
#line 2505 "grid.c"
}

gchar*
grid_to_string (Grid* self)
{
	gchar* ret_string = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 506 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 508 "../src/grid.vala"
	_tmp0_ = g_strdup ("\n");
#line 508 "../src/grid.vala"
	ret_string = _tmp0_;
#line 509 "../src/grid.vala"
	_grid_convert_to_string (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2), &ret_string);
#line 510 "../src/grid.vala"
	result = ret_string;
#line 510 "../src/grid.vala"
	return result;
#line 2526 "grid.c"
}

static void
_grid_convert_to_string (guint8** grid,
                         gint* grid_length1,
                         gint* grid_length2,
                         gchar** ret_string)
{
	guint rows = 0U;
	gint _tmp0_;
	guint cols = 0U;
	gint _tmp1_;
#line 513 "../src/grid.vala"
	g_return_if_fail (*ret_string != NULL);
#line 515 "../src/grid.vala"
	_tmp0_ = *grid_length1;
#line 515 "../src/grid.vala"
	rows = (guint) _tmp0_;
#line 516 "../src/grid.vala"
	_tmp1_ = *grid_length2;
#line 516 "../src/grid.vala"
	cols = (guint) _tmp1_;
#line 2549 "grid.c"
	{
		guint i = 0U;
#line 518 "../src/grid.vala"
		i = (guint) 0;
#line 2554 "grid.c"
		{
			gboolean _tmp2_ = FALSE;
#line 518 "../src/grid.vala"
			_tmp2_ = TRUE;
#line 518 "../src/grid.vala"
			while (TRUE) {
#line 518 "../src/grid.vala"
				if (!_tmp2_) {
#line 2563 "grid.c"
					guint _tmp3_;
#line 518 "../src/grid.vala"
					_tmp3_ = i;
#line 518 "../src/grid.vala"
					i = _tmp3_ + 1;
#line 2569 "grid.c"
				}
#line 518 "../src/grid.vala"
				_tmp2_ = FALSE;
#line 518 "../src/grid.vala"
				if (!(i < rows)) {
#line 518 "../src/grid.vala"
					break;
#line 2577 "grid.c"
				}
				{
					guint j = 0U;
#line 520 "../src/grid.vala"
					j = (guint) 0;
#line 2583 "grid.c"
					{
						gboolean _tmp4_ = FALSE;
#line 520 "../src/grid.vala"
						_tmp4_ = TRUE;
#line 520 "../src/grid.vala"
						while (TRUE) {
#line 2590 "grid.c"
							guint64 val = 0ULL;
							guint8 _tmp6_;
							const gchar* _tmp8_ = NULL;
							gchar* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
#line 520 "../src/grid.vala"
							if (!_tmp4_) {
#line 2599 "grid.c"
								guint _tmp5_;
#line 520 "../src/grid.vala"
								_tmp5_ = j;
#line 520 "../src/grid.vala"
								j = _tmp5_ + 1;
#line 2605 "grid.c"
							}
#line 520 "../src/grid.vala"
							_tmp4_ = FALSE;
#line 520 "../src/grid.vala"
							if (!(j < cols)) {
#line 520 "../src/grid.vala"
								break;
#line 2613 "grid.c"
							}
#line 523 "../src/grid.vala"
							_tmp6_ = (*grid)[(i * (*grid_length2)) + j];
#line 523 "../src/grid.vala"
							if (((gint) _tmp6_) == 0) {
#line 524 "../src/grid.vala"
								val = (guint64) 0;
#line 2621 "grid.c"
							} else {
								guint8 _tmp7_;
#line 526 "../src/grid.vala"
								_tmp7_ = (*grid)[(i * (*grid_length2)) + j];
#line 526 "../src/grid.vala"
								val = (guint64) pow ((gdouble) 2, (gdouble) _tmp7_);
#line 2628 "grid.c"
							}
#line 527 "../src/grid.vala"
							if (j == (cols - 1)) {
#line 527 "../src/grid.vala"
								_tmp8_ = "\n";
#line 2634 "grid.c"
							} else {
#line 527 "../src/grid.vala"
								_tmp8_ = " ";
#line 2638 "grid.c"
							}
#line 527 "../src/grid.vala"
							_tmp9_ = g_strdup_printf ("%llu%s", val, _tmp8_);
#line 527 "../src/grid.vala"
							_tmp10_ = _tmp9_;
#line 527 "../src/grid.vala"
							_tmp11_ = g_strconcat (*ret_string, _tmp10_, NULL);
#line 527 "../src/grid.vala"
							_g_free0 (*ret_string);
#line 527 "../src/grid.vala"
							*ret_string = _tmp11_;
#line 527 "../src/grid.vala"
							_g_free0 (_tmp10_);
#line 2652 "grid.c"
						}
					}
				}
			}
		}
	}
}

static guint8*
_vala_array_dup2 (guint8* self,
                  gssize length)
{
#line 544 "../src/grid.vala"
	if (length > 0) {
#line 544 "../src/grid.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 2669 "grid.c"
	}
#line 544 "../src/grid.vala"
	return NULL;
#line 2673 "grid.c"
}

gboolean
grid_load (Grid* self,
           gchar** content)
{
	guint8* grid = NULL;
	guint8* _tmp0_;
	gint grid_length1;
	gint grid_length2;
	gboolean _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	guint8* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gboolean result;
#line 536 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 536 "../src/grid.vala"
	g_return_val_if_fail (*content != NULL, FALSE);
#line 538 "../src/grid.vala"
	_tmp0_ = g_new0 (guint8, 1 * 0);
#line 538 "../src/grid.vala"
	grid = _tmp0_;
#line 538 "../src/grid.vala"
	grid_length1 = 1;
#line 538 "../src/grid.vala"
	grid_length2 = 0;
#line 539 "../src/grid.vala"
	_tmp1_ = _grid_load_from_string (content, &grid, (gint*) (&grid_length1), (gint*) (&grid_length2));
#line 539 "../src/grid.vala"
	if (!_tmp1_) {
#line 540 "../src/grid.vala"
		result = FALSE;
#line 540 "../src/grid.vala"
		grid = (g_free (grid), NULL);
#line 540 "../src/grid.vala"
		return result;
#line 2722 "grid.c"
	}
#line 542 "../src/grid.vala"
	_tmp2_ = grid;
#line 542 "../src/grid.vala"
	_tmp2__length1 = grid_length1;
#line 542 "../src/grid.vala"
	_tmp2__length2 = grid_length2;
#line 542 "../src/grid.vala"
	_tmp3_ = _tmp2__length1;
#line 542 "../src/grid.vala"
	self->priv->_rows = (guint8) _tmp3_;
#line 543 "../src/grid.vala"
	_tmp4_ = grid;
#line 543 "../src/grid.vala"
	_tmp4__length1 = grid_length1;
#line 543 "../src/grid.vala"
	_tmp4__length2 = grid_length2;
#line 543 "../src/grid.vala"
	_tmp5_ = _tmp4__length2;
#line 543 "../src/grid.vala"
	self->priv->_cols = (guint8) _tmp5_;
#line 544 "../src/grid.vala"
	_tmp6_ = grid;
#line 544 "../src/grid.vala"
	_tmp6__length1 = grid_length1;
#line 544 "../src/grid.vala"
	_tmp6__length2 = grid_length2;
#line 544 "../src/grid.vala"
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup2 (_tmp6_, _tmp6__length1 * _tmp6__length2) : _tmp6_;
#line 544 "../src/grid.vala"
	_tmp7__length1 = _tmp6__length1;
#line 544 "../src/grid.vala"
	_tmp7__length2 = _tmp6__length2;
#line 544 "../src/grid.vala"
	self->_grid = (g_free (self->_grid), NULL);
#line 544 "../src/grid.vala"
	self->_grid = _tmp7_;
#line 544 "../src/grid.vala"
	self->_grid_length1 = _tmp7__length1;
#line 544 "../src/grid.vala"
	self->_grid_length2 = _tmp7__length2;
#line 545 "../src/grid.vala"
	result = TRUE;
#line 545 "../src/grid.vala"
	grid = (g_free (grid), NULL);
#line 545 "../src/grid.vala"
	return result;
#line 2770 "grid.c"
}

static gboolean
uint64_try_parse (const gchar* str,
                  guint64* _result_,
                  const gchar** unparsed,
                  guint _base)
{
	guint64 _vala__result_ = 0ULL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 843 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 845 "glib-2.0.vapi"
	errno = 0;
#line 846 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (str, &_tmp0_, _base);
#line 846 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 846 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 847 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 847 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 847 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 847 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 2806 "grid.c"
		gboolean _tmp5_ = FALSE;
#line 848 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 849 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 849 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 2814 "grid.c"
		} else {
#line 849 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 2818 "grid.c"
		}
#line 849 "glib-2.0.vapi"
		result = _tmp5_;
#line 849 "glib-2.0.vapi"
		if (_result_) {
#line 849 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2826 "grid.c"
		}
#line 849 "glib-2.0.vapi"
		if (unparsed) {
#line 849 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2832 "grid.c"
		}
#line 849 "glib-2.0.vapi"
		return result;
#line 2836 "grid.c"
	} else {
		gchar* _tmp6_;
#line 851 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 851 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 852 "glib-2.0.vapi"
		result = FALSE;
#line 852 "glib-2.0.vapi"
		if (_result_) {
#line 852 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2849 "grid.c"
		}
#line 852 "glib-2.0.vapi"
		if (unparsed) {
#line 852 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2855 "grid.c"
		}
#line 852 "glib-2.0.vapi"
		return result;
#line 2859 "grid.c"
	}
}

static gboolean
_grid_load_from_string (gchar** content,
                        guint8** grid,
                        gint* grid_length1,
                        gint* grid_length2)
{
	gchar** lines = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** tokens = NULL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint tokens_length1;
	gint _tokens_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	guint64 number_64 = 0ULL;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	guint64 _tmp10_ = 0ULL;
	gboolean _tmp11_;
	gboolean _tmp12_ = FALSE;
	guint8 rows = 0U;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	guint64 _tmp15_ = 0ULL;
	gboolean _tmp16_;
	gboolean _tmp17_ = FALSE;
	guint8 cols = 0U;
	gboolean _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	guint8* _tmp20_;
	gboolean result;
#line 548 "../src/grid.vala"
	g_return_val_if_fail (*content != NULL, FALSE);
#line 551 "../src/grid.vala"
	_tmp1_ = _tmp0_ = g_strsplit (*content, "\n", 0);
#line 551 "../src/grid.vala"
	lines = _tmp1_;
#line 551 "../src/grid.vala"
	lines_length1 = _vala_array_length (_tmp0_);
#line 551 "../src/grid.vala"
	_lines_size_ = lines_length1;
#line 554 "../src/grid.vala"
	_tmp2_ = lines;
#line 554 "../src/grid.vala"
	_tmp2__length1 = lines_length1;
#line 554 "../src/grid.vala"
	if (_tmp2__length1 < 4) {
#line 555 "../src/grid.vala"
		result = FALSE;
#line 555 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 555 "../src/grid.vala"
		return result;
#line 2928 "grid.c"
	}
#line 557 "../src/grid.vala"
	_tmp3_ = lines;
#line 557 "../src/grid.vala"
	_tmp3__length1 = lines_length1;
#line 557 "../src/grid.vala"
	_tmp4_ = _tmp3_[0];
#line 557 "../src/grid.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, " ", 0);
#line 557 "../src/grid.vala"
	tokens = _tmp6_;
#line 557 "../src/grid.vala"
	tokens_length1 = _vala_array_length (_tmp5_);
#line 557 "../src/grid.vala"
	_tokens_size_ = tokens_length1;
#line 558 "../src/grid.vala"
	_tmp7_ = tokens;
#line 558 "../src/grid.vala"
	_tmp7__length1 = tokens_length1;
#line 558 "../src/grid.vala"
	if (_tmp7__length1 != 2) {
#line 559 "../src/grid.vala"
		result = FALSE;
#line 559 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 559 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 559 "../src/grid.vala"
		return result;
#line 2958 "grid.c"
	}
#line 563 "../src/grid.vala"
	_tmp8_ = tokens;
#line 563 "../src/grid.vala"
	_tmp8__length1 = tokens_length1;
#line 563 "../src/grid.vala"
	_tmp9_ = _tmp8_[0];
#line 563 "../src/grid.vala"
	_tmp11_ = uint64_try_parse (_tmp9_, &_tmp10_, NULL, (guint) 0);
#line 563 "../src/grid.vala"
	number_64 = _tmp10_;
#line 563 "../src/grid.vala"
	if (!_tmp11_) {
#line 564 "../src/grid.vala"
		result = FALSE;
#line 564 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 564 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 564 "../src/grid.vala"
		return result;
#line 2980 "grid.c"
	}
#line 565 "../src/grid.vala"
	if (number_64 == ((guint64) 0)) {
#line 565 "../src/grid.vala"
		_tmp12_ = TRUE;
#line 2986 "grid.c"
	} else {
#line 565 "../src/grid.vala"
		_tmp12_ = number_64 > ((guint64) 9);
#line 2990 "grid.c"
	}
#line 565 "../src/grid.vala"
	if (_tmp12_) {
#line 566 "../src/grid.vala"
		result = FALSE;
#line 566 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 566 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 566 "../src/grid.vala"
		return result;
#line 3002 "grid.c"
	}
#line 567 "../src/grid.vala"
	rows = (guint8) number_64;
#line 569 "../src/grid.vala"
	_tmp13_ = tokens;
#line 569 "../src/grid.vala"
	_tmp13__length1 = tokens_length1;
#line 569 "../src/grid.vala"
	_tmp14_ = _tmp13_[1];
#line 569 "../src/grid.vala"
	_tmp16_ = uint64_try_parse (_tmp14_, &_tmp15_, NULL, (guint) 0);
#line 569 "../src/grid.vala"
	number_64 = _tmp15_;
#line 569 "../src/grid.vala"
	if (!_tmp16_) {
#line 570 "../src/grid.vala"
		result = FALSE;
#line 570 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 570 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 570 "../src/grid.vala"
		return result;
#line 3026 "grid.c"
	}
#line 571 "../src/grid.vala"
	if (number_64 == ((guint64) 0)) {
#line 571 "../src/grid.vala"
		_tmp17_ = TRUE;
#line 3032 "grid.c"
	} else {
#line 571 "../src/grid.vala"
		_tmp17_ = number_64 > ((guint64) 9);
#line 3036 "grid.c"
	}
#line 571 "../src/grid.vala"
	if (_tmp17_) {
#line 572 "../src/grid.vala"
		result = FALSE;
#line 572 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 572 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 572 "../src/grid.vala"
		return result;
#line 3048 "grid.c"
	}
#line 573 "../src/grid.vala"
	cols = (guint8) number_64;
#line 575 "../src/grid.vala"
	_tmp18_ = grid_is_disallowed_grid_size (&rows, &cols);
#line 575 "../src/grid.vala"
	if (_tmp18_) {
#line 576 "../src/grid.vala"
		result = FALSE;
#line 576 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 576 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 576 "../src/grid.vala"
		return result;
#line 3064 "grid.c"
	}
#line 578 "../src/grid.vala"
	_tmp19_ = lines;
#line 578 "../src/grid.vala"
	_tmp19__length1 = lines_length1;
#line 578 "../src/grid.vala"
	if (_tmp19__length1 < (rows + 2)) {
#line 579 "../src/grid.vala"
		result = FALSE;
#line 579 "../src/grid.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 579 "../src/grid.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 579 "../src/grid.vala"
		return result;
#line 3080 "grid.c"
	}
#line 581 "../src/grid.vala"
	_tmp20_ = g_new0 (guint8, rows * cols);
#line 581 "../src/grid.vala"
	*grid = (g_free (*grid), NULL);
#line 581 "../src/grid.vala"
	*grid = _tmp20_;
#line 581 "../src/grid.vala"
	*grid_length1 = rows;
#line 581 "../src/grid.vala"
	*grid_length2 = cols;
#line 3092 "grid.c"
	{
		guint8 i = 0U;
#line 583 "../src/grid.vala"
		i = (guint8) 0;
#line 3097 "grid.c"
		{
			gboolean _tmp21_ = FALSE;
#line 583 "../src/grid.vala"
			_tmp21_ = TRUE;
#line 583 "../src/grid.vala"
			while (TRUE) {
#line 3104 "grid.c"
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				gchar** _tmp25_ = NULL;
				gint _tmp26_ = 0;
				gchar** _tmp27_;
				gint _tmp27__length1;
#line 583 "../src/grid.vala"
				if (!_tmp21_) {
#line 3114 "grid.c"
					guint8 _tmp22_;
#line 583 "../src/grid.vala"
					_tmp22_ = i;
#line 583 "../src/grid.vala"
					i = _tmp22_ + 1;
#line 3120 "grid.c"
				}
#line 583 "../src/grid.vala"
				_tmp21_ = FALSE;
#line 583 "../src/grid.vala"
				if (!(i < rows)) {
#line 583 "../src/grid.vala"
					break;
#line 3128 "grid.c"
				}
#line 585 "../src/grid.vala"
				_tmp23_ = lines;
#line 585 "../src/grid.vala"
				_tmp23__length1 = lines_length1;
#line 585 "../src/grid.vala"
				_tmp24_ = _tmp23_[i + 1];
#line 585 "../src/grid.vala"
				_grid_parse_line (_tmp24_, &_tmp25_, &_tmp26_);
#line 585 "../src/grid.vala"
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 585 "../src/grid.vala"
				tokens = _tmp25_;
#line 585 "../src/grid.vala"
				tokens_length1 = _tmp26_;
#line 585 "../src/grid.vala"
				_tokens_size_ = tokens_length1;
#line 587 "../src/grid.vala"
				_tmp27_ = tokens;
#line 587 "../src/grid.vala"
				_tmp27__length1 = tokens_length1;
#line 587 "../src/grid.vala"
				if (_tmp27__length1 != ((gint) cols)) {
#line 588 "../src/grid.vala"
					result = FALSE;
#line 588 "../src/grid.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 588 "../src/grid.vala"
					lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 588 "../src/grid.vala"
					return result;
#line 3160 "grid.c"
				}
				{
					guint8 j = 0U;
#line 590 "../src/grid.vala"
					j = (guint8) 0;
#line 3166 "grid.c"
					{
						gboolean _tmp28_ = FALSE;
#line 590 "../src/grid.vala"
						_tmp28_ = TRUE;
#line 590 "../src/grid.vala"
						while (TRUE) {
#line 3173 "grid.c"
							gchar** _tmp30_;
							gint _tmp30__length1;
							const gchar* _tmp31_;
							guint64 _tmp32_ = 0ULL;
							gboolean _tmp33_;
							guint8 number = 0U;
							guint8 _tmp34_ = 0U;
							gboolean _tmp35_;
#line 590 "../src/grid.vala"
							if (!_tmp28_) {
#line 3184 "grid.c"
								guint8 _tmp29_;
#line 590 "../src/grid.vala"
								_tmp29_ = j;
#line 590 "../src/grid.vala"
								j = _tmp29_ + 1;
#line 3190 "grid.c"
							}
#line 590 "../src/grid.vala"
							_tmp28_ = FALSE;
#line 590 "../src/grid.vala"
							if (!(j < cols)) {
#line 590 "../src/grid.vala"
								break;
#line 3198 "grid.c"
							}
#line 592 "../src/grid.vala"
							_tmp30_ = tokens;
#line 592 "../src/grid.vala"
							_tmp30__length1 = tokens_length1;
#line 592 "../src/grid.vala"
							_tmp31_ = _tmp30_[j];
#line 592 "../src/grid.vala"
							_tmp33_ = uint64_try_parse (_tmp31_, &_tmp32_, NULL, (guint) 0);
#line 592 "../src/grid.vala"
							number_64 = _tmp32_;
#line 592 "../src/grid.vala"
							if (!_tmp33_) {
#line 593 "../src/grid.vala"
								result = FALSE;
#line 593 "../src/grid.vala"
								tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 593 "../src/grid.vala"
								lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 593 "../src/grid.vala"
								return result;
#line 3220 "grid.c"
							}
#line 595 "../src/grid.vala"
							_tmp35_ = _grid_convert_tile_number (&number_64, &_tmp34_);
#line 595 "../src/grid.vala"
							number = _tmp34_;
#line 595 "../src/grid.vala"
							if (!_tmp35_) {
#line 596 "../src/grid.vala"
								result = FALSE;
#line 596 "../src/grid.vala"
								tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 596 "../src/grid.vala"
								lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 596 "../src/grid.vala"
								return result;
#line 3236 "grid.c"
							}
#line 597 "../src/grid.vala"
							(*grid)[(i * (*grid_length2)) + j] = number;
#line 3240 "grid.c"
						}
					}
				}
			}
		}
	}
#line 601 "../src/grid.vala"
	result = TRUE;
#line 601 "../src/grid.vala"
	tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 601 "../src/grid.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 601 "../src/grid.vala"
	return result;
#line 3255 "grid.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 610 "../src/grid.vala"
	if ((*length) == (*size)) {
#line 610 "../src/grid.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 610 "../src/grid.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3270 "grid.c"
	}
#line 610 "../src/grid.vala"
	(*array)[(*length)++] = value;
#line 610 "../src/grid.vala"
	(*array)[*length] = NULL;
#line 3276 "grid.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
#line 611 "../src/grid.vala"
	if (length >= 0) {
#line 3285 "grid.c"
		gchar** result;
		gssize i;
#line 611 "../src/grid.vala"
		result = g_new0 (gchar*, length + 1);
#line 611 "../src/grid.vala"
		for (i = 0; i < length; i++) {
#line 3292 "grid.c"
			gchar* _tmp0_;
#line 611 "../src/grid.vala"
			_tmp0_ = g_strdup (self[i]);
#line 611 "../src/grid.vala"
			result[i] = _tmp0_;
#line 3298 "grid.c"
		}
#line 611 "../src/grid.vala"
		return result;
#line 3302 "grid.c"
	}
#line 611 "../src/grid.vala"
	return NULL;
#line 3306 "grid.c"
}

static inline void
_grid_parse_line (const gchar* line,
                  gchar*** tokens,
                  gint* tokens_length1)
{
	gchar** _vala_tokens = NULL;
	gint _vala_tokens_length1 = 0;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tokens = NULL;
	gchar** _tmp2_;
	gint _tokens_length1;
	gint __tokens_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** _tmp9_;
	gint _tmp9__length1;
#line 604 "../src/grid.vala"
	g_return_if_fail (line != NULL);
#line 606 "../src/grid.vala"
	_tmp1_ = _tmp0_ = g_strsplit (line, " ", 0);
#line 606 "../src/grid.vala"
	_vala_tokens = (_vala_array_free (_vala_tokens, _vala_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 606 "../src/grid.vala"
	_vala_tokens = _tmp1_;
#line 606 "../src/grid.vala"
	_vala_tokens_length1 = _vala_array_length (_tmp0_);
#line 607 "../src/grid.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 607 "../src/grid.vala"
	_tokens = _tmp2_;
#line 607 "../src/grid.vala"
	_tokens_length1 = 0;
#line 607 "../src/grid.vala"
	__tokens_size_ = _tokens_length1;
#line 608 "../src/grid.vala"
	_tmp3_ = _vala_tokens;
#line 608 "../src/grid.vala"
	_tmp3__length1 = _vala_tokens_length1;
#line 3350 "grid.c"
	{
		gchar** token_collection = NULL;
		gint token_collection_length1 = 0;
		gint _token_collection_size_ = 0;
		gint token_it = 0;
#line 608 "../src/grid.vala"
		token_collection = _tmp3_;
#line 608 "../src/grid.vala"
		token_collection_length1 = _tmp3__length1;
#line 608 "../src/grid.vala"
		for (token_it = 0; token_it < token_collection_length1; token_it = token_it + 1) {
#line 3362 "grid.c"
			gchar* _tmp4_;
			gchar* token = NULL;
#line 608 "../src/grid.vala"
			_tmp4_ = g_strdup (token_collection[token_it]);
#line 608 "../src/grid.vala"
			token = _tmp4_;
#line 3369 "grid.c"
			{
				const gchar* _tmp5_;
#line 609 "../src/grid.vala"
				_tmp5_ = token;
#line 609 "../src/grid.vala"
				if (g_strcmp0 (_tmp5_, "") != 0) {
#line 3376 "grid.c"
					const gchar* _tmp6_;
					gchar* _tmp7_;
#line 610 "../src/grid.vala"
					_tmp6_ = token;
#line 610 "../src/grid.vala"
					_tmp7_ = g_strdup (_tmp6_);
#line 610 "../src/grid.vala"
					_vala_array_add1 (&_tokens, &_tokens_length1, &__tokens_size_, _tmp7_);
#line 3385 "grid.c"
				}
#line 608 "../src/grid.vala"
				_g_free0 (token);
#line 3389 "grid.c"
			}
		}
	}
#line 611 "../src/grid.vala"
	_tmp8_ = _tokens;
#line 611 "../src/grid.vala"
	_tmp8__length1 = _tokens_length1;
#line 611 "../src/grid.vala"
	_tmp9_ = (_tmp8_ != NULL) ? _vala_array_dup3 (_tmp8_, _tmp8__length1) : _tmp8_;
#line 611 "../src/grid.vala"
	_tmp9__length1 = _tmp8__length1;
#line 611 "../src/grid.vala"
	_vala_tokens = (_vala_array_free (_vala_tokens, _vala_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 611 "../src/grid.vala"
	_vala_tokens = _tmp9_;
#line 611 "../src/grid.vala"
	_vala_tokens_length1 = _tmp9__length1;
#line 604 "../src/grid.vala"
	_tokens = (_vala_array_free (_tokens, _tokens_length1, (GDestroyNotify) g_free), NULL);
#line 604 "../src/grid.vala"
	if (tokens) {
#line 604 "../src/grid.vala"
		*tokens = _vala_tokens;
#line 3413 "grid.c"
	} else {
#line 604 "../src/grid.vala"
		_vala_tokens = (_vala_array_free (_vala_tokens, _vala_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 3417 "grid.c"
	}
#line 604 "../src/grid.vala"
	if (tokens_length1) {
#line 604 "../src/grid.vala"
		*tokens_length1 = _vala_tokens_length1;
#line 3423 "grid.c"
	}
}

static inline gboolean
_grid_convert_tile_number (guint64* number_64,
                           guint8* number)
{
	guint8 _vala_number = 0U;
	gboolean result;
#line 617 "../src/grid.vala"
	if ((*number_64) == ((guint64) 0)) {
#line 619 "../src/grid.vala"
		_vala_number = (guint8) 0;
#line 620 "../src/grid.vala"
		result = TRUE;
#line 620 "../src/grid.vala"
		if (number) {
#line 620 "../src/grid.vala"
			*number = _vala_number;
#line 3443 "grid.c"
		}
#line 620 "../src/grid.vala"
		return result;
#line 3447 "grid.c"
	}
	{
		gboolean _tmp0_ = FALSE;
#line 622 "../src/grid.vala"
		_vala_number = (guint8) 1;
#line 622 "../src/grid.vala"
		_tmp0_ = TRUE;
#line 622 "../src/grid.vala"
		while (TRUE) {
#line 622 "../src/grid.vala"
			if (!_tmp0_) {
#line 3459 "grid.c"
				guint8 _tmp1_;
#line 622 "../src/grid.vala"
				_tmp1_ = _vala_number;
#line 622 "../src/grid.vala"
				_vala_number = _tmp1_ + 1;
#line 3465 "grid.c"
			}
#line 622 "../src/grid.vala"
			_tmp0_ = FALSE;
#line 622 "../src/grid.vala"
			if (!(((gint) _vala_number) <= 81)) {
#line 622 "../src/grid.vala"
				break;
#line 3473 "grid.c"
			}
#line 623 "../src/grid.vala"
			if ((*number_64) == ((guint64) pow ((gdouble) 2, (gdouble) _vala_number))) {
#line 624 "../src/grid.vala"
				result = TRUE;
#line 624 "../src/grid.vala"
				if (number) {
#line 624 "../src/grid.vala"
					*number = _vala_number;
#line 3483 "grid.c"
				}
#line 624 "../src/grid.vala"
				return result;
#line 3487 "grid.c"
			}
		}
	}
#line 626 "../src/grid.vala"
	result = FALSE;
#line 626 "../src/grid.vala"
	if (number) {
#line 626 "../src/grid.vala"
		*number = _vala_number;
#line 3497 "grid.c"
	}
#line 626 "../src/grid.vala"
	return result;
#line 3501 "grid.c"
}

void
grid_save_game (Grid* self,
                const gchar* path)
{
	gchar* contents = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 633 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 633 "../src/grid.vala"
	g_return_if_fail (path != NULL);
#line 635 "../src/grid.vala"
	_tmp0_ = grid_save (self);
#line 635 "../src/grid.vala"
	contents = _tmp0_;
#line 3519 "grid.c"
	{
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 638 "../src/grid.vala"
		_tmp1_ = g_path_get_dirname (path);
#line 638 "../src/grid.vala"
		_tmp2_ = _tmp1_;
#line 638 "../src/grid.vala"
		g_mkdir_with_parents (_tmp2_, 0775);
#line 638 "../src/grid.vala"
		_g_free0 (_tmp2_);
#line 639 "../src/grid.vala"
		g_file_set_contents (path, contents, (gssize) -1, &_inner_error0_);
#line 639 "../src/grid.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 639 "../src/grid.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3537 "grid.c"
				goto __catch0_g_file_error;
			}
#line 639 "../src/grid.vala"
			_g_free0 (contents);
#line 639 "../src/grid.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 639 "../src/grid.vala"
			g_clear_error (&_inner_error0_);
#line 639 "../src/grid.vala"
			return;
#line 3548 "grid.c"
		}
#line 640 "../src/grid.vala"
		g_debug ("grid.vala:640: game saved successfully");
#line 3552 "grid.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 636 "../src/grid.vala"
		e = _inner_error0_;
#line 636 "../src/grid.vala"
		_inner_error0_ = NULL;
#line 643 "../src/grid.vala"
		_tmp3_ = e;
#line 643 "../src/grid.vala"
		_tmp4_ = _tmp3_->message;
#line 643 "../src/grid.vala"
		g_warning ("grid.vala:643: Failed to save game: %s", _tmp4_);
#line 636 "../src/grid.vala"
		_g_error_free0 (e);
#line 3572 "grid.c"
	}
	__finally0:
#line 636 "../src/grid.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 636 "../src/grid.vala"
		_g_free0 (contents);
#line 636 "../src/grid.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 636 "../src/grid.vala"
		g_clear_error (&_inner_error0_);
#line 636 "../src/grid.vala"
		return;
#line 3585 "grid.c"
	}
#line 633 "../src/grid.vala"
	_g_free0 (contents);
#line 3589 "grid.c"
}

gboolean
grid_restore_game (Grid* self,
                   const gchar* path)
{
	gchar* content = NULL;
	gboolean _tmp3_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 647 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 647 "../src/grid.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 3604 "grid.c"
	{
		gchar* _tmp0_ = NULL;
#line 651 "../src/grid.vala"
		g_file_get_contents (path, &_tmp0_, NULL, &_inner_error0_);
#line 651 "../src/grid.vala"
		_g_free0 (content);
#line 651 "../src/grid.vala"
		content = _tmp0_;
#line 651 "../src/grid.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3615 "grid.c"
			gboolean _tmp1_ = FALSE;
#line 651 "../src/grid.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 3619 "grid.c"
				goto __catch0_g_file_error;
			}
#line 651 "../src/grid.vala"
			_g_free0 (content);
#line 651 "../src/grid.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 651 "../src/grid.vala"
			g_clear_error (&_inner_error0_);
#line 651 "../src/grid.vala"
			return _tmp1_;
#line 3630 "grid.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 651 "../src/grid.vala"
		g_clear_error (&_inner_error0_);
#line 652 "../src/grid.vala"
		result = FALSE;
#line 652 "../src/grid.vala"
		_g_free0 (content);
#line 652 "../src/grid.vala"
		return result;
#line 3644 "grid.c"
	}
	__finally0:
#line 651 "../src/grid.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3649 "grid.c"
		gboolean _tmp2_ = FALSE;
#line 651 "../src/grid.vala"
		_g_free0 (content);
#line 651 "../src/grid.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 651 "../src/grid.vala"
		g_clear_error (&_inner_error0_);
#line 651 "../src/grid.vala"
		return _tmp2_;
#line 3659 "grid.c"
	}
#line 654 "../src/grid.vala"
	_tmp3_ = grid_load (self, &content);
#line 654 "../src/grid.vala"
	if (_tmp3_) {
#line 655 "../src/grid.vala"
		result = TRUE;
#line 655 "../src/grid.vala"
		_g_free0 (content);
#line 655 "../src/grid.vala"
		return result;
#line 3671 "grid.c"
	}
#line 657 "../src/grid.vala"
	g_warning ("grid.vala:657: Failed to restore game from saved file");
#line 658 "../src/grid.vala"
	result = FALSE;
#line 658 "../src/grid.vala"
	_g_free0 (content);
#line 658 "../src/grid.vala"
	return result;
#line 3681 "grid.c"
}

guint8
grid_get_rows (Grid* self)
{
	guint8 result;
#line 25 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 25 "../src/grid.vala"
	result = self->priv->_rows;
#line 25 "../src/grid.vala"
	return result;
#line 3694 "grid.c"
}

static void
grid_set_rows (Grid* self,
               guint8 value)
{
#line 25 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/grid.vala"
	self->priv->_rows = value;
#line 3705 "grid.c"
}

guint8
grid_get_cols (Grid* self)
{
	guint8 result;
#line 26 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 26 "../src/grid.vala"
	result = self->priv->_cols;
#line 26 "../src/grid.vala"
	return result;
#line 3718 "grid.c"
}

static void
grid_set_cols (Grid* self,
               guint8 value)
{
#line 26 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/grid.vala"
	self->priv->_cols = value;
#line 3729 "grid.c"
}

guint
grid_get_target_value (Grid* self)
{
	guint result;
#line 28 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 28 "../src/grid.vala"
	result = self->priv->_target_value;
#line 28 "../src/grid.vala"
	return result;
#line 3742 "grid.c"
}

void
grid_set_target_value (Grid* self,
                       guint value)
{
#line 28 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/grid.vala"
	self->priv->_target_value = value;
#line 3753 "grid.c"
}

guint
grid_get_target_value_simple (Grid* self)
{
	guint result;
#line 29 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 29 "../src/grid.vala"
	result = self->priv->_target_value_simple;
#line 29 "../src/grid.vala"
	return result;
#line 3766 "grid.c"
}

static void
grid_set_target_value_simple (Grid* self,
                              guint value)
{
#line 29 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/grid.vala"
	self->priv->_target_value_simple = value;
#line 3777 "grid.c"
}

gboolean
grid_get_target_value_reached (Grid* self)
{
	gboolean result;
#line 30 "../src/grid.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "../src/grid.vala"
	result = self->priv->_target_value_reached;
#line 30 "../src/grid.vala"
	return result;
#line 3790 "grid.c"
}

void
grid_set_target_value_reached (Grid* self,
                               gboolean value)
{
#line 30 "../src/grid.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/grid.vala"
	self->priv->_target_value_reached = value;
#line 3801 "grid.c"
}

static GObject *
grid_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Grid * self;
	gboolean _tmp0_ = FALSE;
	guint8 _tmp1_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	guint8* _tmp5_;
#line 32 "../src/grid.vala"
	parent_class = G_OBJECT_CLASS (grid_parent_class);
#line 32 "../src/grid.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 32 "../src/grid.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GRID, Grid);
#line 34 "../src/grid.vala"
	_tmp1_ = self->priv->_rows;
#line 34 "../src/grid.vala"
	if (((gint) _tmp1_) < 1) {
#line 34 "../src/grid.vala"
		_tmp0_ = TRUE;
#line 3829 "grid.c"
	} else {
		guint8 _tmp2_;
#line 34 "../src/grid.vala"
		_tmp2_ = self->priv->_cols;
#line 34 "../src/grid.vala"
		_tmp0_ = ((gint) _tmp2_) < 1;
#line 3836 "grid.c"
	}
#line 34 "../src/grid.vala"
	if (_tmp0_) {
#line 35 "../src/grid.vala"
		g_assert_not_reached ();
#line 3842 "grid.c"
	}
#line 37 "../src/grid.vala"
	_tmp3_ = self->priv->_rows;
#line 37 "../src/grid.vala"
	_tmp4_ = self->priv->_cols;
#line 37 "../src/grid.vala"
	_tmp5_ = g_new0 (guint8, _tmp3_ * _tmp4_);
#line 37 "../src/grid.vala"
	self->_grid = (g_free (self->_grid), NULL);
#line 37 "../src/grid.vala"
	self->_grid = _tmp5_;
#line 37 "../src/grid.vala"
	self->_grid_length1 = _tmp3_;
#line 37 "../src/grid.vala"
	self->_grid_length2 = _tmp4_;
#line 38 "../src/grid.vala"
	_grid_clear (&self->_grid, (gint*) (&self->_grid_length1), (gint*) (&self->_grid_length2));
#line 32 "../src/grid.vala"
	return obj;
#line 3862 "grid.c"
}

static void
grid_class_init (GridClass * klass,
                 gpointer klass_data)
{
#line 21 "../src/grid.vala"
	grid_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/grid.vala"
	g_type_class_adjust_private_offset (klass, &Grid_private_offset);
#line 21 "../src/grid.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_grid_get_property;
#line 21 "../src/grid.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_grid_set_property;
#line 21 "../src/grid.vala"
	G_OBJECT_CLASS (klass)->constructor = grid_constructor;
#line 21 "../src/grid.vala"
	G_OBJECT_CLASS (klass)->finalize = grid_finalize;
#line 21 "../src/grid.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRID_ROWS_PROPERTY, grid_properties[GRID_ROWS_PROPERTY] = g_param_spec_uchar ("rows", "rows", "rows", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/grid.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRID_COLS_PROPERTY, grid_properties[GRID_COLS_PROPERTY] = g_param_spec_uchar ("cols", "cols", "cols", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/grid.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRID_TARGET_VALUE_PROPERTY, grid_properties[GRID_TARGET_VALUE_PROPERTY] = g_param_spec_uint ("target-value", "target-value", "target-value", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/grid.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRID_TARGET_VALUE_SIMPLE_PROPERTY, grid_properties[GRID_TARGET_VALUE_SIMPLE_PROPERTY] = g_param_spec_uint ("target-value-simple", "target-value-simple", "target-value-simple", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/grid.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRID_TARGET_VALUE_REACHED_PROPERTY, grid_properties[GRID_TARGET_VALUE_REACHED_PROPERTY] = g_param_spec_boolean ("target-value-reached", "target-value-reached", "target-value-reached", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 3891 "grid.c"
}

static void
grid_instance_init (Grid * self,
                    gpointer klass)
{
#line 21 "../src/grid.vala"
	self->priv = grid_get_instance_private (self);
#line 28 "../src/grid.vala"
	self->priv->_target_value = (guint) 0;
#line 29 "../src/grid.vala"
	self->priv->_target_value_simple = (guint) 0;
#line 30 "../src/grid.vala"
	self->priv->_target_value_reached = FALSE;
#line 3906 "grid.c"
}

static void
grid_finalize (GObject * obj)
{
	Grid * self;
#line 21 "../src/grid.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GRID, Grid);
#line 23 "../src/grid.vala"
	self->_grid = (g_free (self->_grid), NULL);
#line 21 "../src/grid.vala"
	G_OBJECT_CLASS (grid_parent_class)->finalize (obj);
#line 3919 "grid.c"
}

static GType
grid_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GridClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) grid_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Grid), 0, (GInstanceInitFunc) grid_instance_init, NULL };
	GType grid_type_id;
	grid_type_id = g_type_register_static (G_TYPE_OBJECT, "Grid", &g_define_type_info, 0);
	Grid_private_offset = g_type_add_instance_private (grid_type_id, sizeof (GridPrivate));
	return grid_type_id;
}

GType
grid_get_type (void)
{
	static volatile gsize grid_type_id__once = 0;
	if (g_once_init_enter (&grid_type_id__once)) {
		GType grid_type_id;
		grid_type_id = grid_get_type_once ();
		g_once_init_leave (&grid_type_id__once, grid_type_id);
	}
	return grid_type_id__once;
}

static void
_vala_grid_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Grid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GRID, Grid);
#line 21 "../src/grid.vala"
	switch (property_id) {
#line 21 "../src/grid.vala"
		case GRID_ROWS_PROPERTY:
#line 21 "../src/grid.vala"
		g_value_set_uchar (value, grid_get_rows (self));
#line 21 "../src/grid.vala"
		break;
#line 21 "../src/grid.vala"
		case GRID_COLS_PROPERTY:
#line 21 "../src/grid.vala"
		g_value_set_uchar (value, grid_get_cols (self));
#line 21 "../src/grid.vala"
		break;
#line 21 "../src/grid.vala"
		case GRID_TARGET_VALUE_PROPERTY:
#line 21 "../src/grid.vala"
		g_value_set_uint (value, grid_get_target_value (self));
#line 21 "../src/grid.vala"
		break;
#line 21 "../src/grid.vala"
		case GRID_TARGET_VALUE_SIMPLE_PROPERTY:
#line 21 "../src/grid.vala"
		g_value_set_uint (value, grid_get_target_value_simple (self));
#line 21 "../src/grid.vala"
		break;
#line 21 "../src/grid.vala"
		case GRID_TARGET_VALUE_REACHED_PROPERTY:
#line 21 "../src/grid.vala"
		g_value_set_boolean (value, grid_get_target_value_reached (self));
#line 21 "../src/grid.vala"
		break;
#line 3984 "grid.c"
		default:
#line 21 "../src/grid.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/grid.vala"
		break;
#line 3990 "grid.c"
	}
}

static void
_vala_grid_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Grid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GRID, Grid);
#line 21 "../src/grid.vala"
	switch (property_id) {
#line 21 "../src/grid.vala"
		case GRID_ROWS_PROPERTY:
#line 21 "../src/grid.vala"
		grid_set_rows (self, g_value_get_uchar (value));
#line 21 "../src/grid.vala"
		break;
#line 21 "../src/grid.vala"
		case GRID_COLS_PROPERTY:
#line 21 "../src/grid.vala"
		grid_set_cols (self, g_value_get_uchar (value));
#line 21 "../src/grid.vala"
		break;
#line 21 "../src/grid.vala"
		case GRID_TARGET_VALUE_PROPERTY:
#line 21 "../src/grid.vala"
		grid_set_target_value (self, g_value_get_uint (value));
#line 21 "../src/grid.vala"
		break;
#line 21 "../src/grid.vala"
		case GRID_TARGET_VALUE_SIMPLE_PROPERTY:
#line 21 "../src/grid.vala"
		grid_set_target_value_simple (self, g_value_get_uint (value));
#line 21 "../src/grid.vala"
		break;
#line 21 "../src/grid.vala"
		case GRID_TARGET_VALUE_REACHED_PROPERTY:
#line 21 "../src/grid.vala"
		grid_set_target_value_reached (self, g_value_get_boolean (value));
#line 21 "../src/grid.vala"
		break;
#line 4034 "grid.c"
		default:
#line 21 "../src/grid.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/grid.vala"
		break;
#line 4040 "grid.c"
	}
}

gchar*
grid_position_to_string (GridPosition *self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 669 "../src/grid.vala"
	_tmp0_ = g_strdup_printf ("%hhi", (*self).row);
#line 669 "../src/grid.vala"
	_tmp1_ = _tmp0_;
#line 669 "../src/grid.vala"
	_tmp2_ = g_strdup_printf ("%hhi", (*self).col);
#line 669 "../src/grid.vala"
	_tmp3_ = _tmp2_;
#line 669 "../src/grid.vala"
	_tmp4_ = g_strconcat ("(", _tmp1_, ",", _tmp3_, ")", NULL);
#line 669 "../src/grid.vala"
	_tmp5_ = _tmp4_;
#line 669 "../src/grid.vala"
	_g_free0 (_tmp3_);
#line 669 "../src/grid.vala"
	_g_free0 (_tmp1_);
#line 669 "../src/grid.vala"
	result = _tmp5_;
#line 669 "../src/grid.vala"
	return result;
#line 4074 "grid.c"
}

GridPosition*
grid_position_dup (const GridPosition* self)
{
	GridPosition* dup;
#line 662 "../src/grid.vala"
	dup = g_new0 (GridPosition, 1);
#line 662 "../src/grid.vala"
	memcpy (dup, self, sizeof (GridPosition));
#line 662 "../src/grid.vala"
	return dup;
#line 4087 "grid.c"
}

void
grid_position_free (GridPosition* self)
{
#line 662 "../src/grid.vala"
	g_free (self);
#line 4095 "grid.c"
}

static GType
grid_position_get_type_once (void)
{
	GType grid_position_type_id;
	grid_position_type_id = g_boxed_type_register_static ("GridPosition", (GBoxedCopyFunc) grid_position_dup, (GBoxedFreeFunc) grid_position_free);
	return grid_position_type_id;
}

GType
grid_position_get_type (void)
{
	static volatile gsize grid_position_type_id__once = 0;
	if (g_once_init_enter (&grid_position_type_id__once)) {
		GType grid_position_type_id;
		grid_position_type_id = grid_position_get_type_once ();
		g_once_init_leave (&grid_position_type_id__once, grid_position_type_id);
	}
	return grid_position_type_id__once;
}

TileMovement*
tile_movement_dup (const TileMovement* self)
{
	TileMovement* dup;
#line 673 "../src/grid.vala"
	dup = g_new0 (TileMovement, 1);
#line 673 "../src/grid.vala"
	memcpy (dup, self, sizeof (TileMovement));
#line 673 "../src/grid.vala"
	return dup;
#line 4128 "grid.c"
}

void
tile_movement_free (TileMovement* self)
{
#line 673 "../src/grid.vala"
	g_free (self);
#line 4136 "grid.c"
}

static GType
tile_movement_get_type_once (void)
{
	GType tile_movement_type_id;
	tile_movement_type_id = g_boxed_type_register_static ("TileMovement", (GBoxedCopyFunc) tile_movement_dup, (GBoxedFreeFunc) tile_movement_free);
	return tile_movement_type_id;
}

GType
tile_movement_get_type (void)
{
	static volatile gsize tile_movement_type_id__once = 0;
	if (g_once_init_enter (&tile_movement_type_id__once)) {
		GType tile_movement_type_id;
		tile_movement_type_id = tile_movement_get_type_once ();
		g_once_init_leave (&tile_movement_type_id__once, tile_movement_type_id);
	}
	return tile_movement_type_id__once;
}

Tile*
tile_dup (const Tile* self)
{
	Tile* dup;
#line 679 "../src/grid.vala"
	dup = g_new0 (Tile, 1);
#line 679 "../src/grid.vala"
	memcpy (dup, self, sizeof (Tile));
#line 679 "../src/grid.vala"
	return dup;
#line 4169 "grid.c"
}

void
tile_free (Tile* self)
{
#line 679 "../src/grid.vala"
	g_free (self);
#line 4177 "grid.c"
}

static GType
tile_get_type_once (void)
{
	GType tile_type_id;
	tile_type_id = g_boxed_type_register_static ("Tile", (GBoxedCopyFunc) tile_dup, (GBoxedFreeFunc) tile_free);
	return tile_type_id;
}

GType
tile_get_type (void)
{
	static volatile gsize tile_type_id__once = 0;
	if (g_once_init_enter (&tile_type_id__once)) {
		GType tile_type_id;
		tile_type_id = tile_get_type_once ();
		g_once_init_leave (&tile_type_id__once, tile_type_id);
	}
	return tile_type_id__once;
}

gchar*
move_request_debug_string (MoveRequest request)
{
	gchar* result;
#line 693 "../src/grid.vala"
	switch (request) {
#line 693 "../src/grid.vala"
		case MOVE_REQUEST_UP:
#line 4208 "grid.c"
		{
			gchar* _tmp0_;
#line 695 "../src/grid.vala"
			_tmp0_ = g_strdup ("move up");
#line 695 "../src/grid.vala"
			result = _tmp0_;
#line 695 "../src/grid.vala"
			return result;
#line 4217 "grid.c"
		}
#line 693 "../src/grid.vala"
		case MOVE_REQUEST_RIGHT:
#line 4221 "grid.c"
		{
			gchar* _tmp1_;
#line 696 "../src/grid.vala"
			_tmp1_ = g_strdup ("move right");
#line 696 "../src/grid.vala"
			result = _tmp1_;
#line 696 "../src/grid.vala"
			return result;
#line 4230 "grid.c"
		}
#line 693 "../src/grid.vala"
		case MOVE_REQUEST_DOWN:
#line 4234 "grid.c"
		{
			gchar* _tmp2_;
#line 697 "../src/grid.vala"
			_tmp2_ = g_strdup ("move down");
#line 697 "../src/grid.vala"
			result = _tmp2_;
#line 697 "../src/grid.vala"
			return result;
#line 4243 "grid.c"
		}
#line 693 "../src/grid.vala"
		case MOVE_REQUEST_LEFT:
#line 4247 "grid.c"
		{
			gchar* _tmp3_;
#line 698 "../src/grid.vala"
			_tmp3_ = g_strdup ("move left");
#line 698 "../src/grid.vala"
			result = _tmp3_;
#line 698 "../src/grid.vala"
			return result;
#line 4256 "grid.c"
		}
		default:
		{
#line 699 "../src/grid.vala"
			g_assert_not_reached ();
#line 4262 "grid.c"
		}
	}
}

static GType
move_request_get_type_once (void)
{
	static const GEnumValue values[] = {{MOVE_REQUEST_UP, "MOVE_REQUEST_UP", "up"}, {MOVE_REQUEST_RIGHT, "MOVE_REQUEST_RIGHT", "right"}, {MOVE_REQUEST_DOWN, "MOVE_REQUEST_DOWN", "down"}, {MOVE_REQUEST_LEFT, "MOVE_REQUEST_LEFT", "left"}, {0, NULL, NULL}};
	GType move_request_type_id;
	move_request_type_id = g_enum_register_static ("MoveRequest", values);
	return move_request_type_id;
}

GType
move_request_get_type (void)
{
	static volatile gsize move_request_type_id__once = 0;
	if (g_once_init_enter (&move_request_type_id__once)) {
		GType move_request_type_id;
		move_request_type_id = move_request_get_type_once ();
		g_once_init_leave (&move_request_type_id__once, move_request_type_id);
	}
	return move_request_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

